/* ========================================
 *
 * Copyright VIOR, 2014
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF VIOR.
 *
 * ========================================
*/
#include <device.h>
#include <stdio.h>

typedef int16 TADCValue;	
typedef int8 TADCSelChan;	

uint8  ADCSelChanelID = 0;
TADCSelChan ADCSelChanelMatr[7] = /*{1, 1, 1, 1, 1, 1, 1}; //*/{0, 1, 2, 0, 1, 3, 4};
TADCSelChan ADCSelChanelCurrStabMatr[7] = {1, 2, 1, 3, 1, 4, 1};
#define ADCSelChanelMatr_HIBound  ((sizeof(ADCSelChanelMatr) / sizeof(TADCSelChan)) - 1)
#define ADCSelChanelCurrStabMatr_HIBound  ((sizeof(ADCSelChanelMatr) / sizeof(TADCSelChan)) - 1)
uint8 CycleChanelChange = 0;  //разбито на этапы, чтобы после изменения входа АЦП, прошло время

uint16 StabilizeCurrent_VDACValue = 0;
//TADCValue ADCValueChan_0[10];
//uint8 ADCValueChan_0_ID = 0;
//TADCValue ADCValueChan_1[10];
//uint8 ADCValueChan_1_ID = 0;
//TADCValue ADCValueChan_2[10];
//uint8 ADCValueChan_2_ID = 0;
//TADCValue ADCValueChan_3[10];
//uint8 ADCValueChan_3_ID = 0;
//TADCValue ADCValueChan_4[10];
//uint8 ADCValueChan_4_ID = 0;

float32 ADCValue2CurrentMeas(TADCValue ADCValue) { //преобразовать значение АЦП в ток нагрузки
float32 fl;	
	fl = ADC_CountsTo_Volts(ADCValue);
	fl = fl - PowerUnit.CurrentOffset;	
	fl = fl / (Current_OpAmpl_GAIN); 
	fl = fl * Current_CompensResDiv; 
	PowerUnit.VoltageDrop = fl;
	fl = fl / Current_SHUNT_Ohm;  		
	if (fl < 0.005) fl = 0.0;	
	return(fl); 		
}

uint8 OverCurrentCuttOff(void) { //преобразовать значение уставки тока защиты в ток отсечки
float32 fl;	
uint8 Res;	
	fl = PowerUnit.CurrentSP;
	if (WorkMode_ModeGET == WM_VoltStab) {
		if (fl < 0.1) fl = 0.1;
	} else {
		fl = fl + fl; //загрубить защиту 
		if (WorkMode_ModeGET == WM_CurrStab) {
			if (fl < 0.5) fl = 0.5;
		} else if (WorkMode_ModeGET == WM_BatteryChrg) {
			if (fl < 1.0) fl = 1.0;
		}
	}
	
	fl = (fl * 1000) / 33.0;	  //1bit=16mV=33mA
	if (PowerUnit.WorkMode & WM_HwPrCurrLowSense) fl = fl * 3; //загрубить защиту
  else fl = fl + (fl / 5.0); //загрубить защиту 
  fl = fl + (PowerUnit.CurrentOffset / 0.016);  //1bit=16mV
	if (fl > 255.0) Res = 255;
	else if (fl < 3) Res = 3; //не менее 3 * 33mA = 100mA
	else Res = fl;
	return(Res); 		
}

float32 ADCValue2VoltageMeas(TADCValue ADCValue) { //преобразовать значение АЦП в выходное напряжение
float32 fl;	
	fl = ADC_CountsTo_Volts(ADCValue);
	fl = fl * VoltOut_ResistDivRatio;
	if (fl < PowerUnit.VoltageCutOff/*0.25*/) fl = 0.0;
	return(fl); 		
}

uint8 OverVoltCuttOff(void) { //преобразовать значение выходного напряжение в значение отсечки по перенапряжению
float32 fl;	
uint8 Res;	
	fl = PowerUnit.VoltageSP;
	fl = fl + 5.0; //загрубить защиту 
//	if (fl < 5.12) fl = 5.12;
	fl = (fl * 1000) / 128.0;	  //1bit=Vin 128mV
//	fl = fl + (fl / 10.0); //загрубить защиту 
	if (fl > 255.0) Res = 255;
	else if (fl < 40) Res = 40; //не менее 20 * 128mV = 2.56V
	else Res = fl;
	return(Res); 		
}

void ADCHandler (void) {
uint8 bt;
TADCSelChan SelChan; 
TADCValue ADCValue;
float fl;
static TSysClk ADCClkCounter = 0xFFFF;	

  if (CycleChanelChange == 99) { //измерение при регулировки тока
	//	bool b;
		TSysClk ClkCounter = SysClkCounter_ReadCounter();
		CycleChanelChange = 0;		
	//	VcompPos_Write(0x01);
		ADC_StopConvert();
		ADC_StartConvert();
		ADC_IsEndConversion(ADC_WAIT_FOR_RESULT);
//		while ((b = (SysClk_GetPeriod(ClkCounter) < 1000)) && 
//					(ADC_IsEndConversion(ADC_RETURN_STATUS) == 0));
//		if (b == FALSE) {
//			CycleChanelChange = 0;
//			ADCSelChanelID = 0;
//			return;
//		}					
	//	VcompPos_Write(0x00);
		SelChan = ADCSelChanelCurrStabMatr[ADCSelChanelID];
		if (++ADCSelChanelID > ADCSelChanelCurrStabMatr_HIBound) ADCSelChanelID = 0;
		
	}	else {
		if (CycleChanelChange == 0) {
			AMux_1_Select(ADCSelChanelMatr[ADCSelChanelID]);
			CycleChanelChange = 1;
			return;
		} else if (CycleChanelChange == 1) {
			ADC_StopConvert();
			ADC_StartConvert();
			CycleChanelChange = 2;
			ADCClkCounter = SysClkCounter_ReadCounter();
			return;
		} else if (SysClk_GetPeriod(ADCClkCounter) >= 2000) {
			CycleChanelChange = 0;
			ADCSelChanelID = 0;
			return;
		}
	  bt = ADC_IsEndConversion(ADC_RETURN_STATUS);
	  if (bt == 0) return;	
		SelChan = ADCSelChanelMatr[ADCSelChanelID];
		if (++ADCSelChanelID > ADCSelChanelMatr_HIBound) ADCSelChanelID = 0;
		AMux_1_Select(ADCSelChanelMatr[ADCSelChanelID]);
		CycleChanelChange = 1;				
	}

	ADCValue = ADC_GetResult16();

	switch (SelChan) {	
  	case 0: { //OutCurr ток нагрузки	
//			ADCValueChan_0[ADCValueChan_0_ID] = ADCValue;
//			if (++ADCValueChan_0_ID >= 10) ADCValueChan_0_ID = 0;
			PowerUnit.CurrentMeas = ADCValue2CurrentMeas(ADCValue);
//			if (PowerUnit.CurrentMeas > 1.0) {
//			  CyDelay (1);	
//			}
			break;
		} 	

	  case 1: { //VoutCtrlInput выходное напряжение
//			ADCValueChan_1[ADCValueChan_1_ID] = ADCValue;
//			if (++ADCValueChan_1_ID >= 10) ADCValueChan_1_ID = 0;
			PowerUnit.VoltageMeas = ADCValue2VoltageMeas(ADCValue);
			PowerUnit.VoltageMeasNew = TRUE;
//			if (PowerUnit.VoltageMeas > 7.0) {
//			  CyDelay (1);	
//			}			
			break;
		} 
		case 2: { //CtrlVolt12 напряжение стабилизатора 12В
//			ADCValueChan_2[ADCValueChan_2_ID] = ADCValue;
//			if (++ADCValueChan_2_ID >= 10) ADCValueChan_2_ID = 0;
			fl = ADC_CountsTo_Volts(ADCValue);
			fl = fl * Volt12V_ResistDivRatio;
			PowerUnit.VoltStab12V = fl;
			break;
		} 
		case 3: { //CtrlVolt24 напряжение стабилизатора 24В
//			ADCValueChan_3[ADCValueChan_3_ID] = ADCValue;
//			if (++ADCValueChan_3_ID >= 10) ADCValueChan_3_ID = 0;
			fl = ADC_CountsTo_Volts(ADCValue);
			fl = fl * Volt24V_ResistDivRatio;
			PowerUnit.VoltStab24V = fl;
			break;
		} 
		case 4: { //MeasAC напряжение питания сети 220В
//			ADCValueChan_4[ADCValueChan_4_ID] = ADCValue;
//			if (++ADCValueChan_4_ID >= 10) ADCValueChan_4_ID = 0;
			fl = ADC_CountsTo_Volts(ADCValue);
			fl = fl * VoltAC_ResistDivRatio;
			PowerUnit.ACVoltage = fl;
			break;
		}
	}
//	ADC_StartConvert();
}




uint16 VoltageSP2DACValue(float VoltageSP) {
uint16 Res;
	VoltageSP = VoltageSP * 0.981; //коррекция соотношения уставки и выход. напряжения
	Res = ((VoltageSP / CtrlVolt_ResistDivRati) / 0.001);
	return (Res);
}

int32 ADC_VoltsTo_Counts(float adcVolts) {
int32 adcCounts;
	adcCounts = adcVolts * ADC_CountsPerVolt;
  adcCounts += ADC_Offset;
  return(adcCounts);
}

TADCValue VoltageSP2ADCValue(float VoltageValue) { //преобразовать выходное напряжение в значение АЦП  
	VoltageValue = VoltageValue / VoltOut_ResistDivRatio;
	return (ADC_VoltsTo_Counts(VoltageValue)); 		
}

TADCValue CurrentSP2ADCValue(float CurrentValue) { //преобразовать ток нагрузки в значение АЦП  
	CurrentValue = CurrentValue * Current_SHUNT_Ohm;
	CurrentValue = CurrentValue / Current_CompensResDiv;
	CurrentValue = CurrentValue * Current_OpAmpl_GAIN;
	CurrentValue = CurrentValue + PowerUnit.CurrentOffset;
	return (ADC_VoltsTo_Counts(CurrentValue)); 		
}

bool WaitVoltageDownToZero (/*TSysClk Duration, */float VoltZero) {
uint16 cnt;
TSysClk ClkCounter = SysClkCounter_ReadCounter();	
bool b;
//float fl;
bool bFirst = TRUE;
TADCValue ADCValue;
TADCValue VoltZero_t = VoltageSP2ADCValue(VoltZero + PowerUnit.VoltageCutOff);
	cnt = 0;
	DAC_OutCtrl_SetValue(VoltageSP2DACValue(VoltZero));
	b = TRUE;
  ADCValue = SHRT_MAX;
	ADC_StopConvert();
	AMux_1_DisconnectAll();
	AMux_1_Select(1);//VoutCtrlInput выходное напряжение
	while ((ADCValue > VoltZero_t) || (cnt++ < 30)) { //дождаться когда напряжение регулятора уменьшиться (разрядится конденсатор на выходе регулятора), что бы не было скачка при включении
		ADC_StartConvert();
		ADC_IsEndConversion(ADC_WAIT_FOR_RESULT);
		ADCValue = ADC_GetResult16(); 				
	}
	return (b);
}

void ReturnToCommonADCScan(void) {
	if (++ADCSelChanelID > ADCSelChanelMatr_HIBound) ADCSelChanelID = 0;
	CycleChanelChange = 0;
}

void OnPowerUP_SetVoltage (bool AWithRelayON) { //плавное нарастание выходного напряжения 
#define OnPowerUP_SetVoltage_MaxDuration  2000	
uint16 wrSP, wrSPRise, wrInc, cnt/*, cnt1*/;
TSysClk ClkCounter = SysClkCounter_ReadCounter();	
TSysClk Duration;
bool b;
float VoltZero;
int16 i16;
TADCValue ADCValue, CurrentSP;
//bool bFirst = TRUE;
  if (WorkMode_ModeGET == WM_VoltStab) {  /*Режим стабилизации напряжения*/
		wrSP = VoltageSP2DACValue(PowerUnit.VoltageSP);	
		if (CheckKeyPressed(KEY_CAPSenseLo)) {  //без нарастания напряжения			
			VoltZero = 0.0;
			
			b = WaitVoltageDownToZero(VoltZero);
			if (b) {
				if (AWithRelayON) {
					RelayPowerON();	
					CyDelay (10); //Relay Operate/release time max., DC coil 8/6ms
				}
				wrSPRise = VoltageSP2DACValue(VoltZero);
				wrInc = (wrSP / 20) + 1;
				while (wrSPRise <= wrSP) {
					DAC_OutCtrl_SetValue(wrSPRise);
					i16 = (wrSPRise + wrInc) - wrSP; 
					if (i16 > 0) {
						wrInc = (i16 / 2) + 1;
					}
					wrSPRise += wrInc;
					CyDelayUs (10);  //Effective update rate  12 bits ( 4V Range )    15 ksps
				}		
			}
			ReturnToCommonADCScan();
		} else {
			if (CheckKeyPressed(KEY_CAPSenseHi)) { //большая входная емкость
				wrInc = 1;
		    Duration = OnPowerUP_SetVoltage_MaxDuration;
			} else {  //средняя входная емкость
				wrInc = 5;
		    Duration = OnPowerUP_SetVoltage_MaxDuration / 2;
			}			
			VoltZero = 0.0;
			b = WaitVoltageDownToZero(/*Duration, */VoltZero);
			wrSPRise = VoltageSP2DACValue(VoltZero);	
			
			if (b) { //теперь плавно поднять напряжение, с контролем потребляемого тока
				cnt = 0;
				b = TRUE;
				if (AWithRelayON) {
					RelayPowerON();	
					CyDelay (100); //Relay Operate/release time max., DC coil 8/6ms
				}
				ClkCounter = SysClkCounter_ReadCounter();
				ADCValue = 0;
				{uint16 btCuttOff = OverCurrentCuttOff(); //загрубить токовую защиту, от всплеска при поднятии напряжения
					if (CheckKeyPressed(KEY_CAPSenseHi)) { //большая входная емкость
						btCuttOff *= 8;
					}	else btCuttOff *= 4;					
					
					if (btCuttOff > 255) btCuttOff = 255;
//					else if (btCuttOff < 60) btCuttOff = 60;  //1bit=16mV=33mA  ограничить срабатывание защиты от 2А
					VDAC_CurrProt_SetValue(btCuttOff & 0x00FF);
				}
				CurrentSP = CurrentSP2ADCValue(PowerUnit.CurrentSP);//(CurrentSP / 2);	
				ADC_StopConvert();
				AMux_1_DisconnectAll();
				AMux_1_Select(0);//OutCurr ток нагрузки	
				while ((wrSPRise <= wrSP) && (/*TRUE || */((b = (SysClk_GetPeriod(ClkCounter) < Duration)) != FALSE))) {	

					if (!PowerUnit.HwPrSupressed && (ReadOutputError() & OUTSTAT_ErrALL)) {
						b = FALSE;
						break;
					}
		
					if (cnt % wrInc == 0) {
						ADC_StartConvert();  //проверить выходной ток
						ADC_IsEndConversion(ADC_WAIT_FOR_RESULT);
						ADCValue = ADC_GetResult16(); //fl = ADCValue2CurrentMeas(ADC_GetResult16()); 
					}
					cnt++;
					if (ADCValue < CurrentSP) { 
						DAC_OutCtrl_SetValue(wrSPRise);
						if (wrSPRise + wrInc > wrSP) wrInc = 1;
						wrSPRise += wrInc;
						PowerUnit.CurrentMax = 0;
					} else {
					//	CyDelayUs(100);
						cnt = 0;
						PowerUnit.CurrentMax = ADCValue2CurrentMeas(ADCValue);
					}
				}
			}
			if ((b == FALSE) && !PowerUnit.HwPrSupressed) {
				RelayPowerOFF();	
				DAC_OutCtrl_SetValue(wrSP);
				GlobalError_SET (ERR_Output_HighCurr);
				LED_HighCurrentIsON();
			}				
			VDAC_CurrProt_SetValue(OverCurrentCuttOff());//HwPrNoOverCurrent_OFF();
			ReturnToCommonADCScan();				
		}	
	} else if (WorkMode_ModeGET == WM_CurrStab) {
	  if (AWithRelayON) RelayPowerON();		
	} else if (WorkMode_ModeGET == WM_BatteryChrg) {
	  if (AWithRelayON) RelayPowerON();		
	}
}

void VoltageSP_Inc (float IncValue) {
	PowerUnit.VoltageSP += IncValue;
	if (PowerUnit.VoltageSP > VOLTAGE_MAX) PowerUnit.VoltageSP = VOLTAGE_MAX;	
	if (WorkMode_ModeGET == WM_VoltStab) DAC_OutCtrl_SetValue(VoltageSP2DACValue(PowerUnit.VoltageSP));
	VDAC_OverVolt_SetValue(OverVoltCuttOff());	
}

void VoltageSP_Dec (float DecValue) {
	PowerUnit.VoltageSP -= DecValue;
	if (PowerUnit.VoltageSP < VOLTAGE_MIN) PowerUnit.VoltageSP = VOLTAGE_MIN;	
	if (WorkMode_ModeGET == WM_VoltStab) DAC_OutCtrl_SetValue(VoltageSP2DACValue(PowerUnit.VoltageSP));
	VDAC_OverVolt_SetValue(OverVoltCuttOff());
}
	
void CurrentSP_Inc (float IncValue) {
	PowerUnit.CurrentSP += IncValue;
	if (PowerUnit.CurrentSP > CURRENT_MAX) PowerUnit.CurrentSP = CURRENT_MAX;	
	VDAC_CurrProt_SetValue(OverCurrentCuttOff());
}
void CurrentSP_Dec (float DecValue) {
	PowerUnit.CurrentSP -= DecValue;
	if (PowerUnit.CurrentSP < CURRENT_MIN) PowerUnit.CurrentSP = CURRENT_MIN;	
	VDAC_CurrProt_SetValue(OverCurrentCuttOff());
}

void ResetStabilizeCurrentVDACValue (void) {
	if (StabilizeCurrent_VDACValue == 0) return;
	StabilizeCurrent_VDACValue = 0;	
	DAC_OutCtrl_SetValue(StabilizeCurrent_VDACValue);	
}

bool StabilizeCurrent (TSysClk MaxDuration, float Current) {
uint16 MaxVDACValue, VDACValue10, VDACValueInc, VDACValueInc2, VDACValueInc5, VDACValueInc10;
TSysClk ClkCounter = SysClkCounter_ReadCounter();	
TADCValue ADCValue, CurrentMeas, ADCValueSP, DiffPerc_02, DiffPerc_1, DiffPerc_5, DiffPerc_10;
uint8 bt;
bool b;
  ADC_StopConvert();
//	AMuxSeq_1_DisconnectAll();
//	AMuxSeq_1_Next();
	ADC_StopConvert();
	AMux_1_DisconnectAll();
	AMux_1_Select(0);//OutCurr ток нагрузки	
	MaxVDACValue = VoltageSP2DACValue(PowerUnit.VoltageSP);
	VDACValue10 = MaxVDACValue / 10;
	
	ADCValueSP = CurrentSP2ADCValue(Current);
	DiffPerc_02 = ADCValueSP / 500;
	if (DiffPerc_02 == 0) DiffPerc_02 = 2;
	DiffPerc_1 = ADCValueSP / 100;
	if (DiffPerc_1 == 0) DiffPerc_1 = 1;
	DiffPerc_5 = ADCValueSP / 20;
	if (DiffPerc_5 == 0) DiffPerc_5 = 5;
	DiffPerc_10 = ADCValueSP / 10;
	if (DiffPerc_10 == 0) DiffPerc_10 = 10;

	if (CheckKeyPressed(KEY_CAPSenseLo)) VDACValueInc = 3;  //без нарастания напряжения
	else if (CheckKeyPressed(KEY_CAPSenseHi)) VDACValueInc = 1;  //большая входная емкость
	else VDACValueInc = 2;  //средняя входная емкость
	if (CheckKeyPressed(KEY_CAPSenseHi)) VDACValueInc2 = VDACValueInc;
	else VDACValueInc2 = VDACValueInc * 2;
	VDACValueInc5 = VDACValueInc * 5;
	VDACValueInc10 = VDACValueInc * 10;	
	while (/*TRUE ||*/ (b = (SysClk_GetPeriod(ClkCounter) < MaxDuration))) {			
		ADC_StartConvert();	
		ADC_IsEndConversion(ADC_WAIT_FOR_RESULT);
//		while (ADC_IsEndConversion(ADC_RETURN_STATUS) == 0); 		
		bt = ReadOutputError();
		if (bt & OUTSTAT_ErrALL) break;
		CurrentMeas = ADC_GetResult16();
		if (CurrentMeas < ADCValueSP) {
			ADCValue = ADCValueSP - CurrentMeas;
			if (ADCValue > DiffPerc_10) {
				StabilizeCurrent_VDACValue += VDACValueInc2;
			} else if (ADCValue > DiffPerc_1) {
				StabilizeCurrent_VDACValue += VDACValueInc;
			} else if ((ADCValue <= DiffPerc_02)) {
				break;
			}		
		} else if (CurrentMeas > ADCValueSP) {
			ADCValue = CurrentMeas - ADCValueSP;

			if ((ADCValue > DiffPerc_10) && (StabilizeCurrent_VDACValue > VDACValueInc10)) {
				StabilizeCurrent_VDACValue -= VDACValueInc10;
			} else if ((ADCValue > DiffPerc_5) && (StabilizeCurrent_VDACValue > VDACValueInc5)) {
				StabilizeCurrent_VDACValue -= VDACValueInc5;
			} else if ((ADCValue > DiffPerc_1) && (StabilizeCurrent_VDACValue > VDACValueInc)) {
				StabilizeCurrent_VDACValue -= VDACValueInc;
			} else if ((ADCValue <= DiffPerc_02)) {
				break;
			}
		} else break;
		
		if (StabilizeCurrent_VDACValue > MaxVDACValue) {
			StabilizeCurrent_VDACValue = MaxVDACValue;
			DAC_OutCtrl_SetValue(StabilizeCurrent_VDACValue);
			if (WorkMode_ModeGET != WM_BatteryChrg) break;
		}	else {
			DAC_OutCtrl_SetValue(StabilizeCurrent_VDACValue);
		//	if ((StabilizeCurrent_VDACValue < VDACValue10)) { 
				if (CheckKeyPressed(KEY_CAPSenseHi)) CyDelay (2);  //большая входная емкость
				else if (!CheckKeyPressed(KEY_CAPSenseLo)) CyDelay (1);  //средняя входная емкость				
		//	}	
		}		
	//	CyDelay (VDACValueInc * 1);
	} 
	if (b == FALSE) {
		ADC_StopConvert();	
	}
	CycleChanelChange = 99;
	AMux_1_Select(ADCSelChanelCurrStabMatr[ADCSelChanelID]);
	//CyDelay(10);
//  {bool b = TRUE;
//		AMux_1_Select(1);//VoutCtrlInput выходное напряжение
//		ADC_StartConvert();
//		while ((b = (SysClk_GetPeriod(ClkCounter) < MaxDuration)) && 
//					(ADC_IsEndConversion(ADC_RETURN_STATUS) == 0));
//		if (b == TRUE) {
//			PowerUnit.VoltageMeas = ADCValue2VoltageMeas(ADC_GetResult16());
//			PowerUnit.VoltageMeasNew = TRUE;
//		}		
//	}
//	if (ADCValue2CurrentMeas(CurrentMeas) > 1) {
//	  CyDelay(1);	
//	}
	PowerUnit.CurrentMeas = ADCValue2CurrentMeas(CurrentMeas);	
//	ReturnToCommonADCScan();
	return (TRUE);
} 	

bool CalibrateCurrentChanel (void) {
#define Calibrate_MaxDuration  4000
float offset = 99.9;
float offsetPrev = 99.9;
uint8 VDACValue = 0xFF;//0xCE; //3.3V 
int8 offsIncCnt = 0;
TSysClk ClkCounter = SysClkCounter_ReadCounter();	
char LCDString[16];
//bool b;
  
  ADC_StopConvert();
//	AMuxSeq_1_DisconnectAll();
//	AMuxSeq_1_Next();		
	ADC_StopConvert();	
	AMux_1_DisconnectAll();
	AMux_1_Select(0);//OutCurr ток нагрузки	
//	ADC_SetBufferGain(ADC_BUF_GAIN_2X);
	LCD_Char_ClearDisplay();
	LCD_Char_Position(0u, 0u);
  LCD_Char_PrintString("Calibr curr offs");
	
	while (SysClk_GetPeriod(ClkCounter) < Calibrate_MaxDuration) {
	  VDAC_CurrCompens_SetValue(VDACValue); 	
		sprintf(LCDString,   "DAC:%03u OFS:%4.1f", (int)VDACValue, offset);
		LCD_Char_Position(1u, 0u);
	  LCD_Char_PrintString(LCDString);
		ADC_StartConvert();
		ADC_IsEndConversion(ADC_WAIT_FOR_RESULT);
//		while (((b = (SysClk_GetPeriod(ClkCounter) < Calibrate_MaxDuration)) != FALSE) && (ADC_IsEndConversion(ADC_RETURN_STATUS) == 0)); //измерять не дольше 4 сек
//		if (b == FALSE) break;
		
		offset = ADC_CountsTo_Volts(ADC_GetResult16());

		if (offset > offsetPrev) {
			if (offsIncCnt++ >= 5) {
			  PowerUnit.CurrentOffset = offset /*/ 2*/;	 //ADC_BUF_GAIN_2X
				GlobalError_CLEAR(ERR_Calibrate);
				return (TRUE);
			}			
		}	else /*if (offset < offsetPrev)*/{
			offsIncCnt = 0;						
		}
		VDACValue--;	
		offsetPrev = offset;		
	} 
	GlobalError_SET(ERR_Calibrate);
	return (FALSE);
} 	

bool CalibrateVoltageChanel (void) {
float CutOff;
float CutOffPrev = 99.9;
TSysClk ClkCounter = SysClkCounter_ReadCounter();	
char LCDString[16];
bool b;  
uint16 cnt;
TADCValue ADCValue;
	DAC_OutCtrl_SetValue(0);
	b = TRUE;
  ADCValue = SHRT_MAX;
	ADC_StopConvert();
	AMux_1_DisconnectAll();
	AMux_1_Select(1);//VoutCtrlInput выходное напряжение
	LCD_Char_ClearDisplay();
	LCD_Char_Position(0u, 0u);
  LCD_Char_PrintString("Calibrat voltage");	
	cnt = 0;
	while ((SysClk_GetPeriod(ClkCounter) < 4000) && (cnt < 10)) {	
		sprintf(LCDString,   "CUTOFF:%6.3f  ", CutOff);
		LCD_Char_Position(1u, 0u);
	  LCD_Char_PrintString(LCDString);
		ADC_StartConvert();
		ADC_IsEndConversion(ADC_WAIT_FOR_RESULT);
//		while (((b = (SysClk_GetPeriod(ClkCounter) < 4000)) != FALSE) && 
//			(ADC_IsEndConversion(ADC_RETURN_STATUS) == 0)); //измерять не дольше 4 сек
//		if (b == FALSE) break;	
		ADCValue = ADC_GetResult16();
		CutOff = ADC_CountsTo_Volts(ADCValue);		
		if (CutOff > CutOffPrev + (CutOffPrev / 10)) {
			cnt = 0;
		} else {
			if (CutOff < CutOffPrev) {
				CutOffPrev = CutOff;
				cnt = 0;
			} else cnt++;
		}
	} 
	PowerUnit.VoltageCutOff = 0;
	PowerUnit.VoltageCutOff = (CutOffPrev + (CutOffPrev / 3)) * VoltOut_ResistDivRatio;	
	if (!b) GlobalError_SET(ERR_Calibrate);
	return (b);
} 	
	
bool CalibrateAnalog(void) {
uint16 wr;	
bool Res = TRUE; 
	HwPrNoOverCurrent_ON();
	HwPrNoOverVoltage_ON();
	OutputControlFastSw(TRUE);
	if (!CalibrateCurrentChanel()) Res = FALSE;
	if (!CalibrateVoltageChanel()) Res = FALSE;
  wr = Comp_CurrProt_ZeroCal();
	Comp_CurrProt_LoadTrim(wr);	
  wr = Comp_OverVolt_ZeroCal();
	Comp_OverVolt_LoadTrim(wr);	
	HwPrErrorClr();
	HwPrNoOverCurrent_OFF();
	HwPrNoOverVoltage_OFF();
	ReturnToCommonADCScan();
	return(Res);
}

float GetBatteryChargeLevel(void) {
float fl, fl1;
	fl = PowerUnit.VoltageSP * 0.8; //индицировать только последние 20%	
	fl = PowerUnit.VoltageMeas - fl; 
	fl1 = PowerUnit.VoltageSP * 0.2;
	return(100.0 / (fl1 / fl));	
}
/* [] END OF FILE */
