/* ========================================
 *
 * Copyright VIOR, 2014
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF VIOR.
 *
 * ========================================
*/

/* [] END OF FILE */

#include <project.h>
#include <device.h>

void InitSystem (void) {
#ifndef DEBUG
	CyWdtStart(CYWDT_1024_TICKS, CYWDT_LPMODE_DISABLED); 
#endif

	PowerUnit.Error = ERR_None;
	PowerUnit.WorkMode = WM_Init;
	PowerUnit.LCDMenu = LM_PowerOFF;
	PowerUnit.RadiatorTemperature = TEMPER_NOT_CONV;
	PowerUnit.CPUTemperature = TEMPER_NOT_CONV;
	PowerUnit.CurrentOffset = 0;
	PowerUnit.VoltageMeasNew = FALSE;
	PowerUnit.HwPrSupressed = FALSE;
	EEPROM_Start();
	SysClkCounter_Start();
	OutputControl (FALSE);
}

void InitAnalog (void) {
//uint8 bt;	
	OutVoltAmpl_Start();
	VDAC_CurrCompens_Start();
	VDAC_CurrCompens_SetValue(0xCE); //3.3V
	CurrCompensAmpl_Start();
	OutCurrAmpl_1_Start();
	VDAC_CurrProt_Start();
	VDAC_CurrProt_SetValue(0xFF);
	Comp_CurrProt_Start();
	
	VDAC_OverVolt_Start();
	VDAC_OverVolt_SetValue(0xFF);
	Comp_OverVolt_Start();
	DAC_OutCtrl_Start();
	DAC_OutCtrl_SetValue(0x00);
	OA_OutVolt_Start();	
	AMux_1_Start();
  ADC_Start();	
	PowerUnit.VoltageSP = 0.0;
	VoltageSP_Inc(5.2);
	PowerUnit.CurrentSP = 0.0;
	CurrentSP_Inc(0.1);
}

void InitDisplay (void) {
	LCD_Char_Start();
}

void InitFan (void) {
	FanController_Start();
	FanController_SetDutyCycle(1u, 0);
}

void InitOutput (void) {
	FAN_ON_Write(0x00);
	OUT_ON_R_Write(0x00);
	ControlOutput_Write(0);
}
