/* ========================================
 *
 * Copyright VIOR, 2014
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF VIOR.
 *
 * ========================================
*/

/* [] END OF FILE */

#include <device.h>
#include <stdio.h>

#define LCDMENU_PERIOD_DEFAULT 300
#define LCDMENU_BACK_TO_MAINMENU 20000
TSysClk LCDMenuPeriod = LCDMENU_PERIOD_DEFAULT;	
TSysClk LCDMenuBackToMainMenu = 0xFFFF;	


void LCDMenu_ModeNEXT(void) {
	if (LCDMenu_ModeGET >= LM_LAST) LCDMenu_ModeSET(LM_FIRST) 
	else LCDMenu_ModeSET(LCDMenu_ModeGET + LM_INC);
}

void LCDMenu_ModePREV(void) {
	if (LCDMenu_ModeGET <= LM_FIRST) LCDMenu_ModeSET(LM_LAST) 
	else LCDMenu_ModeSET(LCDMenu_ModeGET - LM_INC);
}

void LCDMenu_SelWMNEXT(void) {
	if (LCDMenu_SelWMGET >= LM_SelWM_LAST) LCDMenu_SelWMSET(LM_SelWM_FIRST) 
	else LCDMenu_SelWMSET(LCDMenu_SelWMGET + LM_SelWM_INC);
}

void LCDMenu_SelWMPREV(void) {
	if (LCDMenu_SelWMGET <= LM_SelWM_FIRST) LCDMenu_SelWMSET(LM_SelWM_LAST) 
	else LCDMenu_SelWMSET(LCDMenu_SelWMGET - LM_SelWM_INC);
}

void LCDMenuSelWM2WorkMode(void) {
	if (LCDMenu_SelWMGET == LM_SelWM_VoltStab) WorkMode_ModeSET(WM_VoltStab)
	else if (LCDMenu_SelWMGET == LM_SelWM_CurrStab) WorkMode_ModeSET(WM_CurrStab)
	else if (LCDMenu_SelWMGET == LM_SelWM_BatteryChrg) WorkMode_ModeSET(WM_BatteryChrg)
}

void WorkMode2LCDMenuSelWM(void) {
	if (WorkMode_ModeGET == WM_VoltStab) LCDMenu_SelWMSET(LM_SelWM_VoltStab) 
	else if (WorkMode_ModeGET == WM_CurrStab) LCDMenu_SelWMSET(LM_SelWM_CurrStab)
	else if (WorkMode_ModeGET == WM_BatteryChrg) LCDMenu_SelWMSET(LM_SelWM_BatteryChrg)
}

#define LCDMenu_SelWMGET (PowerUnit.LCDMenu & LM_SelWMMASK)

#define LM_SelWMMASK 					0x000F
#define LM_SelWM_VoltStab 		0x0001
#define LM_SelWM_CurrStab 		0x0002
#define LM_SelWM_BatteryChrg	0x0003



int8 ChangeValues(uint8 Keys, int8 PeriodDec) {
int8 Res = 0;	
	if (!(PowerUnit.LCDMenu & LM_ChangeValue)) {
		if (Keys & KEY_OK) PowerUnit.LCDMenu |= LM_ChangeValue;				
		LCD_Char_Position(0u, 15u);
		LCD_Char_PrintString(" ");				
  } else {
	//	uint8 KeysS = ~KeyStatus_Read();
		if (Keys & KEY_OK) {
			PowerUnit.LCDMenu &= ~LM_ChangeValue;
			LCDMenuPeriod = LCDMENU_PERIOD_DEFAULT;
		} else {
			 if (CheckKeyPressed_1s(KEY_UP)) {
				Res = +1;
				if (LCDMenuPeriod > (LCDMENU_PERIOD_DEFAULT / 10)) LCDMenuPeriod -= (LCDMENU_PERIOD_DEFAULT / PeriodDec);
			} else if (CheckKeyPressed_1s(KEY_DOWN)) {
				Res = -1;
				if (LCDMenuPeriod > (LCDMENU_PERIOD_DEFAULT / 10)) LCDMenuPeriod -= (LCDMENU_PERIOD_DEFAULT / PeriodDec);
			} else {
				LCDMenuPeriod = LCDMENU_PERIOD_DEFAULT;
				if (Keys & KEY_UP) {
					Res = +1;
				} else if (Keys & KEY_DOWN) {
					Res = -1;
				}
			}
		} 			
		LCD_Char_Position(0u, 15u);
		LCD_Char_PrintString("*");				
	}	
	return (Res);
}

void LCD_IndicError (uint8 * pKeys) {
static int8 ErrIndicNum = 0;	
uint8 ErrCnt = 0;
char LCDString[10][16];		

	if (PowerUnit.Error & ERR_OneWire_NoDevice) sprintf(LCDString[ErrCnt++],   	"1Wire:No device ");
	if (PowerUnit.Error & ERR_OneWire_BusShort) sprintf(LCDString[ErrCnt++],   	"1Wire:Bus short ");
	if (PowerUnit.Error & ERR_OneWire_Config) sprintf(LCDString[ErrCnt++],   		"1Wire:Config xx ");
	if (PowerUnit.Error & ERR_Mouse_NoDevice) sprintf(LCDString[ErrCnt++],   		"PS/2:No device  ");
	if (PowerUnit.Error & ERR_Mouse_NoWheel) sprintf(LCDString[ErrCnt++],   		"PS/2:No wheel   ");
	if (PowerUnit.Error & ERR_Output_HighCurr) sprintf(LCDString[ErrCnt++],   	"Out:Hi current  ");
	if (PowerUnit.Error & ERR_Output_HighVoltage) sprintf(LCDString[ErrCnt++],  "Out:Hi voltage  ");
	if (PowerUnit.Error & ERR_Output_PowerMonFail) sprintf(LCDString[ErrCnt++], "Out:Power monit ");
	if (PowerUnit.Error & ERR_Output_NoBreaker) sprintf(LCDString[ErrCnt++], 		"Out:No breaker  ");
	if (PowerUnit.Error & ERR_Calibrate) sprintf(LCDString[ErrCnt++], 		      "Can't calibrate ");
  if (ErrCnt == 0) {
		LCDMenu_IndicErrorRESET();
		return;
	}
	ErrCnt--;
	if (*pKeys & KEY_OK) {
		ResetError();
		*pKeys &= ~KEY_OK;
	} else if (*pKeys & KEY_UP) {
		ErrIndicNum++;
		*pKeys &= ~KEY_UP;
	} else if (*pKeys & KEY_DOWN) {
		ErrIndicNum--;
		*pKeys &= ~KEY_DOWN;
	}
	
	if (ErrIndicNum < 0) ErrIndicNum = ErrCnt;
	else if (ErrIndicNum > ErrCnt) ErrIndicNum = 0;

	LCD_Char_Position(1u, 0u);
	LCD_Char_PrintString(LCDString[ErrIndicNum]);

	LCD_Char_Position(0u, 0u);
	sprintf(LCDString[0],   "ERROR %02u of %02u  ", (unsigned int)(ErrIndicNum + 1), (unsigned int)(ErrCnt + 1));
	LCD_Char_PrintString(LCDString[0]);		

}

void LCDMenuBackToMainMenuReset (void) {
  LCDMenuBackToMainMenu = SysClkCounter_ReadCounter();	
}

void LCDMenuHandler (void) {
int8 i;	
uint8 Keys;	
char LCDString[16];	
static TSysClk LCDMenuClkCounter = 0xFFFF;	
	if (!(PowerUnit.LCDMenu & LM_NewData) && !SysClk_CheckPeriod(&LCDMenuClkCounter, LCDMenuPeriod)) return; 
	PowerUnit.LCDMenu &= ~LM_NewData;  /*данные для дисплея изменились, обновить без задержек*/
	Keys = KeyStatus_Gr0_Read();	
	if (Keys != 0) LCDMenuBackToMainMenuReset();
	if (LCDMenu_ModeGET == LM_PowerOFF) {  /*индикация при выключенном устройстве*/
		LCD_Char_Position(0u, 0u);
  	LCD_Char_PrintString(" *PoWOPro-001*  ");
		sprintf(LCDString,   "AC:%3dV  t:%+03dC ", (int)PowerUnit.ACVoltage, (int)PowerUnit.RadiatorTemperature);
		LCD_Char_Position(1u, 0u);
    LCD_Char_PrintString(LCDString);
		PowerUnit.LCDMenu &= ~LM_ChangeValue;
	} else {
		if (PowerUnit.LCDMenu & LM_ExcStored) {  /*Необходимость сохранения*/
			LCD_Char_Position(0u, 0u);
	  	LCD_Char_PrintString("Store changes?  ");
			LCD_Char_Position(1u, 0u);
	  	LCD_Char_PrintString("Press OK 4s if Y");		
			PowerUnit.LCDMenu &= ~LM_ChangeValue;
	  } else if (PowerUnit.LCDMenu & LM_IndicError) {  /*Индикация ошибок*/
			LCD_IndicError(&Keys);
			PowerUnit.LCDMenu &= ~LM_ChangeValue;			
	  } else {			
			if (LCDMenu_ModeGET == LM_PowerON) {  /*индикация при включенном устройстве*/
				LCD_Char_Position(0u, 0u);
				if (WorkMode_ModeGET == WM_VoltStab) {
					LCD_Char_PrintString        (" VOLTAGE stabil ");
					sprintf(LCDString,   "V:%4.1fV Im:%4.2fA ", PowerUnit.VoltageSP, PowerUnit.CurrentSP);
				} else if (WorkMode_ModeGET == WM_CurrStab) {
					LCD_Char_PrintString   (" CURRENT stabil ");
					sprintf(LCDString,   "Vm:%4.1fV I:%4.2fA ", PowerUnit.VoltageSP, PowerUnit.CurrentSP);
				} else if (WorkMode_ModeGET == WM_BatteryChrg) {
					LCD_Char_PrintString(" BATTERY charger");
					sprintf(LCDString,   "V:%4.1fV  I:%4.2fA ", PowerUnit.VoltageSP, PowerUnit.CurrentSP);
				}	else {
					LCD_Char_PrintString("    ?????????   ");
					sprintf(LCDString,   "V:%4.1fV  I:%4.2fA ", PowerUnit.VoltageSP, PowerUnit.CurrentSP);
				}		
				LCD_Char_Position(1u, 0u);
		    LCD_Char_PrintString(LCDString);
				if (Keys & KEY_OK) {
//					ResetError();
					if (PowerUnit.Error & ERR_NewError) {
						ResetError();
					} else OutputControlChng();		
				}
			} else {
				if (!(PowerUnit.LCDMenu & LM_ChangeValue) && (SysClk_GetPeriod(LCDMenuBackToMainMenu) >= LCDMENU_BACK_TO_MAINMENU)) LCDMenu_ModeSET(LM_PowerON);
				
				if (LCDMenu_ModeGET == LM_SelectWorkMode) {  /*выбор режима работы*/
					LCD_Char_Position(0u, 0u);
			  	LCD_Char_PrintString("Select WorkMode ");		
					
					if (!(PowerUnit.LCDMenu & LM_ChangeValue)) {
						if (Keys & KEY_OK) {
							PowerUnit.LCDMenu |= LM_ChangeValue;	
							WorkMode2LCDMenuSelWM();
						}
						LCD_Char_Position(0u, 15u);
						LCD_Char_PrintString(" ");				
				  } else {
						if (Keys & KEY_OK) {
							PowerUnit.LCDMenu &= ~LM_ChangeValue;
							LCDMenuPeriod = LCDMENU_PERIOD_DEFAULT;
							LCDMenuSelWM2WorkMode();
						} else {
							if (Keys & KEY_UP) {
								LCDMenu_SelWMNEXT();
							} else if (Keys & KEY_DOWN) {
								LCDMenu_SelWMPREV();
							}
						} 			
						LCD_Char_Position(0u, 15u);
						LCD_Char_PrintString("*");				
					}	
					
					LCD_Char_Position(1u, 0u);
					if (LCDMenu_SelWMGET == LM_SelWM_VoltStab) LCD_Char_PrintString(" VOLTAGE stabil ");
					else if (LCDMenu_SelWMGET == LM_SelWM_CurrStab) LCD_Char_PrintString(" CURRENT stabil ");
					else if (LCDMenu_SelWMGET == LM_SelWM_BatteryChrg) LCD_Char_PrintString(" BATTERY charger");
					else WorkMode2LCDMenuSelWM(); //LCD_Char_PrintString("    ?????????   ");	
					
				} else if (LCDMenu_ModeGET == LM_CurrentChng) {  /*установить значение тока*/
					if (WorkMode_ModeGET == WM_VoltStab) {
						sprintf(LCDString,   "I maxim: %4.2fA  ", PowerUnit.CurrentSP);
					} else if (WorkMode_ModeGET == WM_CurrStab) {
						sprintf(LCDString,   "I set pnt: %4.2fA", PowerUnit.CurrentSP);
					} else if (WorkMode_ModeGET == WM_BatteryChrg) {
						sprintf(LCDString,   "I charge: %4.2fA ", PowerUnit.CurrentSP);
					}	else {
						sprintf(LCDString,   "I maxim: %4.2fA  ", PowerUnit.CurrentSP);
					}
					LCD_Char_Position(1u, 0u);
			    LCD_Char_PrintString(LCDString);		
					LCD_Char_Position(0u, 0u);
			  	LCD_Char_PrintString("Set new current ");		
					
					i = ChangeValues(Keys, 15);
					if (i > 0) {
						CurrentSP_Inc(0.01);
					} else if (i < 0) {
						CurrentSP_Dec(0.01); 
					}
				} else if (LCDMenu_ModeGET == LM_VoltageChng) {  /*установить значение напряжения*/
					if (WorkMode_ModeGET == WM_VoltStab) {
						sprintf(LCDString,   "V set pnt: %4.1fV", PowerUnit.VoltageSP);
					} else if (WorkMode_ModeGET == WM_CurrStab) {
						sprintf(LCDString,   "V maxim: %4.1fV  ", PowerUnit.VoltageSP);
					} else if (WorkMode_ModeGET == WM_BatteryChrg) {
						sprintf(LCDString,   "V full: %4.1fV   ", PowerUnit.VoltageSP);
					}	else {
						sprintf(LCDString,   "V set pnt: %4.1fV", PowerUnit.VoltageSP);
					}
					LCD_Char_Position(1u, 0u);
			    LCD_Char_PrintString(LCDString);
					LCD_Char_Position(0u, 0u);
			  	LCD_Char_PrintString("Set new voltage");
					
					i = ChangeValues(Keys, 10);
					if (i > 0) {
						VoltageSP_Inc(0.1);
					} else if (i < 0) {
						VoltageSP_Dec(0.1); 
					}					
				} else if (LCDMenu_ModeGET == LM_IndPower) {  /*индикация потребляемой мощности*/
					LCD_Char_Position(0u, 0u);
			  	LCD_Char_PrintString("Power of load W ");		
					sprintf(LCDString,   "meas:%3.0f max:%3.0f ", PowerUnit.VoltageMeas * PowerUnit.CurrentMeas, PowerUnit.VoltageSP * PowerUnit.CurrentSP);
					LCD_Char_Position(1u, 0u);
			    LCD_Char_PrintString(LCDString);
				} else if (LCDMenu_ModeGET == LM_IndTemper) {  /*индикация температуры внутри устройства*/
					LCD_Char_Position(0u, 0u);
			  	LCD_Char_PrintString("  Temperature   ");		
					sprintf(LCDString,   "sys:%+03d rad:%+03d ", (int)PowerUnit.CPUTemperature, (int)PowerUnit.RadiatorTemperature);
					LCD_Char_Position(1u, 0u);
			    LCD_Char_PrintString(LCDString);
				} else if (LCDMenu_ModeGET == LM_IntVoltages) {  /*индикация напряжений внутренних стабилизаторов*/
					LCD_Char_Position(0u, 0u);
			  	LCD_Char_PrintString("Intern stab volt");		
					sprintf(LCDString,   "H:%4.1fV L:%4.1fV ", PowerUnit.VoltStab24V, PowerUnit.VoltStab12V);
					LCD_Char_Position(1u, 0u);
			    LCD_Char_PrintString(LCDString);
				} 
			}
		}
		if (!(PowerUnit.LCDMenu & LM_ChangeValue)) {
			if (Keys & KEY_UP) {
				LCDMenu_ModeNEXT();
				if (LCDMenu_ModeGET == LM_Errors) {  /*ошибки*/
					LCDMenu_IndicErrorSET();
					LCDMenu_ModeNEXT();
				}
			} else if (Keys & KEY_DOWN) {
				LCDMenu_ModePREV();
				if (LCDMenu_ModeGET == LM_Errors) {  /*ошибки*/
					LCDMenu_IndicErrorSET();
					LCDMenu_ModePREV();
				}
			}
	  }
		{uint8 bt = KeyStatus_Gr0_4s_Read(); //проверка долговременного нажатия кнопок
			if (bt) { 
				if (bt & KEY_UP) {
					PowerUnit.WorkMode |= WM_HwPrCurrLowSense;
					CurrentSP_Inc(0.0);	
				} else if (bt & KEY_DOWN) {
					PowerUnit.WorkMode &= ~WM_HwPrCurrLowSense;
					CurrentSP_Inc(0.0);	
				}
			}
		}
	}
}
