/* ========================================
 *
 * Copyright VIOR, 2014
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF VIOR.
 *
 * ========================================
*/

/* [] END OF FILE */
#include <device.h>

TSysClk LEDBarClkCounter = 0xFFFF;
uint8 CAPSenseTmr = 0;

void StartLEDDisplay (void) {
	LED_Driver_Start();
	LED_Driver_SetBrightness(0xFF, 0u);
	LED_Driver_SetBrightness(0xFF, 1u);
	LED_Driver_SetBrightness(0xFF, 2u);
	LED_Driver_SetBrightness(0x3F, 3u);
	LED_Driver_SetBrightness(0x3F, 4u);
	LED_Driver_SetBrightness(0x3F, 5u);
	LED_Driver_SetBrightness(0xFF, 6u);
	LED_Driver_SetBrightness(0xFF, 7u);
//	LED_Driver_PutDecimalPoint(1, 1);
//	LED_Driver_PutDecimalPoint(1, 4);	
}

void StopLEDDisplay (void) {
	LED_Driver_Stop();
}

void LEDDisplay_ShowMeasured (void) {
int LEDVoltage;
int	LEDCurrent; 		
static TSysClk LEDDisplayClkCounter = 0xFFFF;	
	if (!SysClk_CheckPeriod(&LEDDisplayClkCounter, 200)) return; 
	LEDVoltage = (PowerUnit.VoltageMeas - PowerUnit.VoltageDrop) * 10;
	LED_Driver_Write7SegNumberDec(LEDVoltage, 0u, 3, LED_Driver_RIGHT_ALIGN);
	if (LEDVoltage < 10) LED_Driver_Write7SegDigitDec(0, 1);
	LED_Driver_PutDecimalPoint(1, 1);
	
	if (!(PowerUnit.Error & ERR_Output_HighCurr)) {
  	LEDCurrent = PowerUnit.CurrentMeas * 100;
	} else {
		LEDCurrent = PowerUnit.CurrentMax * 100;
	}
	
	if (!(PowerUnit.Error & ERR_Output_HighCurr) || (CAPSenseTmr & 0x01)) {
		LED_Driver_SetBrightness(0x3F, 3u);
		LED_Driver_SetBrightness(0x3F, 4u);
		LED_Driver_SetBrightness(0x3F, 5u);		
	} else {
		LED_Driver_SetBrightness(0x7F, 3u);
		LED_Driver_SetBrightness(0x7F, 4u);
		LED_Driver_SetBrightness(0x7F, 5u);
	}
	
	LED_Driver_Write7SegNumberDec(LEDCurrent, 3u, 3, LED_Driver_RIGHT_ALIGN);
	if (LEDCurrent < 100) LED_Driver_Write7SegDigitDec(0, 3);
	if (LEDCurrent < 10) LED_Driver_Write7SegDigitDec(0, 4);
	LED_Driver_PutDecimalPoint(1, 3);	
	
	CAPSenseTmr++;
	if ((CheckKeyPressed(KEY_CAPSenseLo)) != 0) LED_CAPSenseIsLow();
	else {		
		if ((CheckKeyPressed(KEY_CAPSenseHi)) != 0) {
			if (CAPSenseTmr & 0x04) LED_CAPSenseIsHigh();
			else LED_CAPSenseIsLow();
		} else {
			if (CAPSenseTmr & 0x08) LED_CAPSenseIsHigh();
			else LED_CAPSenseIsLow();	
		}
	}
	
	if (PowerUnit.Error & ERR_SYSTEM) {
		if (PowerUnit.Error & ERR_NewError) {
			if (CAPSenseTmr & 0x02) LED_ErrorIsON();
			else LED_ErrorIsOFF();
	
		} else {
			LED_ErrorIsON();
		}
	} else LED_ErrorIsOFF();
	
	if (PowerUnit.Error & ERR_OUTPUT) {
		if ((CAPSenseTmr & 0x05) == 0x05) {
			LED_OutputIsON();
		} else LED_OutputIsOFF();	
	} else {
		if (OUT_ON_R_Read() != 0/*(OutputStatus_Read() & OUTSTAT_OutputIsON) != 0*/) LED_OutputIsON();
		else LED_OutputIsOFF();

	}	
	if (PowerUnit.WorkMode & WM_HwPrCurrLowSense) LED_HwPrCurrLowSense();
  else LED_HwPrCurrNrmSense();

}

void LEDDisplay_ShowBarInVoltStab (void) {	
float LoadPerc;
	if (!SysClk_CheckPeriod(&LEDBarClkCounter, 100)) return; 
	LoadPerc = 100.0 / (PowerUnit.CurrentSP / PowerUnit.CurrentMeas);
	if (LoadPerc > 0.01) LED_Load10IsON();
	else LED_Load10IsOFF();
	if (LoadPerc > 10.0) LED_Load20IsON();
	else LED_Load20IsOFF();
	if (LoadPerc > 20.0) LED_Load30IsON();
	else LED_Load30IsOFF();
	if (LoadPerc > 40.0) LED_Load40IsON();
	else LED_Load40IsOFF();
	if (LoadPerc > 50.0) LED_Load50IsON();
	else LED_Load50IsOFF();
	if (LoadPerc > 60.0) LED_Load60IsON();
	else LED_Load60IsOFF();
	if (LoadPerc > 70.0) LED_Load70IsON();
	else LED_Load70IsOFF();
	if (LoadPerc > 80.0) LED_Load80IsON();
	else LED_Load80IsOFF();
	if (LoadPerc > 90.0) LED_Load90IsON();
	else LED_Load90IsOFF();
	if (LoadPerc >= 95.0) LED_Load100IsON();
	else LED_Load100IsOFF();
}

void LEDDisplay_ShowBarInCurrStab (void) {
float LoadPerc;
	if (!SysClk_CheckPeriod(&LEDBarClkCounter, 100)) return; 
	LoadPerc = 100.0 / (PowerUnit.CurrentSP / PowerUnit.CurrentMeas);
	
	if (LoadPerc > 145.0) LED_Load100IsON();
	else LED_Load100IsOFF();
	if (LoadPerc > 135.0) LED_Load90IsON();
	else LED_Load90IsOFF();
	if (LoadPerc > 125.0) LED_Load80IsON();
	else LED_Load80IsOFF();
	if (LoadPerc > 115.0) LED_Load70IsON();
	else LED_Load70IsOFF();
	if (LoadPerc > 95.0) LED_Load60IsON();
	else LED_Load60IsOFF();
		
	if (LoadPerc < 105.0) LED_Load50IsON();
	else LED_Load50IsOFF();
	if (LoadPerc < 85.0) LED_Load40IsON();
	else LED_Load40IsOFF();
	if (LoadPerc < 75.0) LED_Load30IsON();
	else LED_Load30IsOFF();
	if (LoadPerc < 65.0) LED_Load20IsON();
	else LED_Load20IsOFF();
	if (LoadPerc < 55.0) LED_Load10IsON();
	else LED_Load10IsOFF();
}

void LEDDisplay_ShowBarInBatteryChrg (void) {
float ChrgPerc;
	if (!SysClk_CheckPeriod(&LEDBarClkCounter, 100)) return; 
	ChrgPerc = GetBatteryChargeLevel();
	
	if (PowerUnit.VoltageMeas >= 0.005) LED_Load10IsON();
	else LED_Load10IsOFF();
	if (ChrgPerc > 10.0) LED_Load20IsON();
	else LED_Load20IsOFF();
	if (ChrgPerc > 20.0) LED_Load30IsON();
	else LED_Load30IsOFF();
	if (ChrgPerc > 40.0) LED_Load40IsON();
	else LED_Load40IsOFF();
	if (ChrgPerc > 50.0) LED_Load50IsON();
	else LED_Load50IsOFF();
	if (ChrgPerc > 60.0) LED_Load60IsON();
	else LED_Load60IsOFF();
	if (ChrgPerc > 70.0) LED_Load70IsON();
	else LED_Load70IsOFF();
	if (ChrgPerc > 80.0) LED_Load80IsON();
	else LED_Load80IsOFF();
	if (ChrgPerc > 90.0) LED_Load90IsON();
	else LED_Load90IsOFF();
	if (ChrgPerc >= 95.0) LED_Load100IsON();
	else LED_Load100IsOFF();
}