/* ========================================
 *
 * Copyright VIOR, 2014
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF VIOR.
 *
 * ========================================
*/


#include <device.h>

bool TemperInit = TRUE;
uint16 OneWireErrCnt = 0;

bool BusReset(void) {
  switch (OneWire_BusReset()) {
		case 1:	    {
			if (OneWireErrCnt < 20) return(FALSE); 
			GlobalError_SET (ERR_OneWire_NoDevice); 
			return(FALSE); 
			break;
		}
		case 255:   {
			if (OneWireErrCnt < 20) return(FALSE); 
			GlobalError_SET (ERR_OneWire_BusShort); 
			return(FALSE); 
			break; 
		}
		default: {
			OneWireErrCnt = 0; 
			GlobalError_CLEAR(ERR_OneWire_NoDevice | ERR_OneWire_BusShort);
		}
	}
	return(TRUE);
}

bool ReadTemper(void) {
uint8 bt;	
	if (!BusReset()) return(FALSE);
  
	OneWire_Write8(0xAC);  //READ STATUS
	bt = OneWire_Read8();	
	
	if ((bt & (/*0x10 | 0x08 |*/ 0x04 | 0x01)) /*|| !(bt & 0x01)*/ || TemperInit) {			//Check bits 1SHOT & T\R in config register of DS1821
		TemperInit = FALSE;
    if (!BusReset()) return(FALSE);
		OneWire_Write8(0x0C);  //WRITE STATUS
  	OneWire_Write8(0x00);
		if (!BusReset()) return(FALSE);
		OneWire_Write8(0xAC);  //READ STATUS
		bt = OneWire_Read8();
	  if ((bt & (0x04 | 0x01)) /*|| !(bt & 0x01)*/) {			//Check bits 1SHOT & T\R in config register of DS1821
	    GlobalError_SET (ERR_OneWire_Config); 
			return(TEMPER_ERR); 
	  }	
		GlobalError_CLEAR(ERR_OneWire_Config);
		if (!BusReset()) return(FALSE);
		OneWire_Write8(0xEE);   //START CONVERT T
  }
	
  if (!BusReset()) return(FALSE);
  OneWire_Write8(0xAA); 
  bt = OneWire_Read8();
  PowerUnit.RadiatorTemperature = bt;
	return(TRUE);
}

bool CheckTemper(void) {
static TSysClk TemperClkCounter = 0xFFFF;	
	if (!SysClk_CheckPeriod(&TemperClkCounter, 500)) return(FALSE); 

	if (!ReadTemper()) {
		if (OneWireErrCnt++ >= 20) {
			PowerUnit.RadiatorTemperature = TEMPER_ERR; //return(FALSE);
		}
	}
	{ int16 CPUTemperature;
		cystatus st = DieTemp_Query(&CPUTemperature);
	  if (st == CYRET_SUCCESS) PowerUnit.CPUTemperature = (int8)CPUTemperature;
		DieTemp_Start();
	}
	if (PowerUnit.RadiatorTemperature >= 80) {
		FanController_SetDutyCycle(1u, 10000);
		FAN_ON_Write(0x01);	
	} else if (PowerUnit.RadiatorTemperature >= 70) {
		FanController_SetDutyCycle(1u, 9000);
		FAN_ON_Write(0x01);	
	} else if (PowerUnit.RadiatorTemperature >= 60) {
		FanController_SetDutyCycle(1u, 7000);
		FAN_ON_Write(0x01);	
	} else if (PowerUnit.RadiatorTemperature >= 50) {
		FanController_SetDutyCycle(1u, 5000);
		FAN_ON_Write(0x01);	
	} else if (PowerUnit.RadiatorTemperature >= 40) {
		FanController_SetDutyCycle(1u, 3000);
		FAN_ON_Write(0x01);	
	} else if ((WorkMode_ModeGET != WM_PowerOFF) && (PowerUnit.RadiatorTemperature >= 35)) {
		FanController_SetDutyCycle(1u, 1000);
		FAN_ON_Write(0x01);	
	} else if (PowerUnit.CPUTemperature >= 40) {
		FanController_SetDutyCycle(1u, 7000);
		FAN_ON_Write(0x01);	
	} else {
		FanController_SetDutyCycle(1u, 0);
		FAN_ON_Write(0x00);	
	} 
	return(TRUE);
}

/* [] END OF FILE */
