/* ========================================
 *
 * Copyright VIOR, 2014
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF VIOR.
 *
 * ========================================
*/

/* [] END OF FILE */

#include <device.h>

uint8 PowerUnitCRC (uint8 * pDevice) {
uint8 Res = 0;	
int8 i;
	for (i = 0; i < (int8)CYDEV_EEPROM_ROW_SIZE; ++i) {
		Res += *(pDevice++);
	}
	return (Res);
}

bool GlbStateRestore (void) {
TDevice PowerUnit_t;
PTDevice pPowerUnit;
	pPowerUnit = (TDevice CYXDATA *)CYDEV_EE_BASE;
	memcpy (&PowerUnit_t, pPowerUnit, CYDEV_EEPROM_ROW_SIZE);

	PowerUnit_t.EEPR_CRC = 0;
	PowerUnit_t.EEPR_DUMMY = 0;
	PowerUnit_t.EEPR_CRC = PowerUnitCRC ((uint8 *) &PowerUnit_t);
	if ((PowerUnit_t.EEPR_CRC == pPowerUnit->EEPR_CRC) && ((PowerUnit_t.WorkMode & WM_ModeMASK) >= WM_FIRST)) {
		PowerUnit = PowerUnit_t;
		return (TRUE);
	} else return (FALSE);
}

void GlbStateStore (void) {
TDevice PowerUnit_t;
cystatus writeStatus;
int16 CPUTemperature;	
	PowerUnit_t = PowerUnit;
	PowerUnit_t.EEPR_CRC = 0;
	PowerUnit_t.EEPR_DUMMY = 0;
	PowerUnit_t.EEPR_CRC = PowerUnitCRC ((uint8 *) &PowerUnit_t);
	while (DieTemp_Query(&CPUTemperature) != CYRET_SUCCESS);
	while (CySetTemp() != CYRET_SUCCESS);
	writeStatus = EEPROM_Write((uint8 *)&PowerUnit_t, 0u);
	if (writeStatus == CYRET_SUCCESS) return;
	else EEPROM_StartWrite((uint8 *)&PowerUnit_t, 0u);

}

void GlbStateReset (void) {
	WorkMode_ModeSET (WM_FIRST);
  PowerUnit.VoltageSP = 0.0;
	VoltageSP_Inc(5.2);
	PowerUnit.CurrentSP = 0.0;
	CurrentSP_Inc(0.1);
}

void OutputControlFastSw (bool AOn) {	
	if (AOn) {
		ControlOutput_Write((ControlOutput_Read() | 0x02) & ~0x01);	
		ControlOutput_Write(ControlOutput_Read() | 0x01);
		ControlOutput_Write(ControlOutput_Read() & ~0x01);
	} else {	   
		ControlOutput_Write(ControlOutput_Read() & ~0x03);	
	}
}

void OutputControl (bool AOn) {
	if (AOn) {
		OnPowerUP_SetVoltage(TRUE);
		//if (!(bt & OUTSTAT_OutputIsON) & (PowerUnit.VoltageMeas < PowerUnit.VoltageSP + 0.5)) {
			VoltageSP_Inc(0.0); //включить защиту по перенапряжению			
	//	}
	} else {	   
		RelayPowerOFF();//OUT_ON_R_Write(0x00);	
	}
}

void OutputControlChng (void) {
//uint8 bt = OutputStatus_Read(); 	
 // if ((bt & OUTSTAT_OutputIsON) == 0) OutputControl(TRUE);
  if (OUT_ON_R_Read() == 0) OutputControl(TRUE);
	else OutputControl(FALSE);
}

uint8 ReadOutputError (void) {
uint8 bt = OutputStatus_Read();	
  if (bt & OUTSTAT_ErrOverVoltage) GlobalError_SET(ERR_Output_HighVoltage);	
  if (bt & OUTSTAT_ErrOverCurrent) GlobalError_SET(ERR_Output_HighCurr);
  if (bt & OUTSTAT_ErrPowerMonFail) GlobalError_SET(ERR_Output_PowerMonFail);
	return(bt);
}

bool ResetError(void) {
uint8 bt, btPrev;	
	HwPrErrorClr(); 
	PowerUnit.CurrentMax = 0;
	btPrev = ReadOutputError();
	if (!(btPrev & OUTSTAT_OutputIsON)) {
		VDAC_CurrProt_SetValue(0xFF); //отключить защиту по току
		VDAC_OverVolt_SetValue(0xFF); //отключить защиту по перенапряжению
	}
	LCDMenu_IndicErrorRESET();
	OutputControlFastSw(TRUE);
	if (!(btPrev & OUTSTAT_OutputIsON)) {
		CurrentSP_Inc(0.0); //включить защиту по току			
	}	
	bt = ReadOutputError();
	if (bt & OUTSTAT_ErrALL) return (FALSE);
	if (PowerUnit.Error & ERR_Output_HighVoltage) GlobalError_CLEAR(ERR_Output_HighVoltage);	
	if (PowerUnit.Error & ERR_Output_HighCurr) GlobalError_CLEAR(ERR_Output_HighCurr);	
	if (PowerUnit.Error & ERR_Output_PowerMonFail) GlobalError_CLEAR(ERR_Output_PowerMonFail);	
	
	PowerUnit.Error &= ~ERR_NewError;	
	LED_ErrorIsOFF();
	LED_HighCurrentIsOFF();
	return (TRUE);
}

void WorkMode_ModeNEXT(void) {
	if (WorkMode_ModeGET >= WM_LAST) WorkMode_ModeSET(WM_FIRST) 
	else WorkMode_ModeSET(WorkMode_ModeGET + WM_INC);
}

void WorkMode_ModePREV(void) {
	if (WorkMode_ModeGET <= WM_FIRST) WorkMode_ModeSET(WM_LAST) 
	else WorkMode_ModeSET(WorkMode_ModeGET - WM_INC);
}

//void WorkMode_ModeSET (TWorkMode Mode) {
//  PowerUnit.WorkMode = (PowerUnit.WorkMode & ~WM_ModeMASK) | Mode;
//	if (Mode == )
//}



void WorkModeHandler (void) {
uint8 bt;
float fl;	
static float VoltageMeasPrev = 0;
//uint8 KeysS = ~KeyStatus_Read();

	if (WorkMode_ModeGET == WM_Init) {  /*Иницилизация*/
		WorkMode_ModeSET(WM_PowerOFF);
	} else if (WorkMode_ModeGET == WM_PowerOFF) {  /*Выключено*/
		if (CheckKeyPressed(KEY_POWER)) {
			MainPowerON();

			if (!GlbStateRestore()) GlbStateReset();		
			WorkMode_ModeSET(WorkMode_ModeGET);
			DAC_OutCtrl_Start();
			DAC_OutCtrl_SetValue(0x00);
			StartLEDDisplay();
			LCDMenu_ModeSET(LM_PowerON);
			PowerUnit.Error = ERR_None;
			CalibrateAnalog();
			ResetError();	
			VoltageSP_Inc(0.0);
			CurrentSP_Inc(0.0);					
		} else {
			if (PowerUnit.WorkMode & WM_ModeChange) {						
				OutputControl (FALSE);
				StopLEDDisplay();
				LCDMenu_ModeSET(LM_PowerOFF);
				PowerUnit.WorkMode &= ~WM_ModeChange;
				OutputControlFastSw(FALSE);		
				DAC_OutCtrl_Stop();
				MainPowerOFF();
			}		
		}
	} else {
		if (!PowerUnit.HwPrSupressed) {
	    bt = ReadOutputError();
			if (bt & OUTSTAT_ErrALL) {
				OutputControl(FALSE);
				if (bt & OUTSTAT_ErrOverCurrent) {
					LED_HighCurrentIsON();	
				}
				if (((WorkMode_ModeGET == WM_CurrStab) || (WorkMode_ModeGET == WM_BatteryChrg)) && 
						(bt & (OUTSTAT_ErrOverCurrent | OUTSTAT_ErrOverVoltage))) {	
					ResetStabilizeCurrentVDACValue();
				}
			}
			
			if (!(PowerUnit.Error & ERR_Output_HighCurr) && 
			  ( (((WorkMode_ModeGET == WM_VoltStab) && (PowerUnit.CurrentMeas > PowerUnit.CurrentSP)) ||
				   (PowerUnit.CurrentMeas > (PowerUnit.CurrentSP + (PowerUnit.CurrentSP / 2)))))) {
				PowerUnit.CurrentMax = PowerUnit.CurrentMeas;
				OutputControl(FALSE);
				GlobalError_SET (ERR_Output_HighCurr);
				LED_HighCurrentIsON();			
			}	
			
			if (!(PowerUnit.Error & ERR_Output_HighVoltage)) {
				if ( ((PowerUnit.CurrentMeas >= 0.01) && 
						 (PowerUnit.VoltageMeas > (PowerUnit.VoltageSP + (PowerUnit.VoltageSP / 2)))
						)) {
					OutputControl(FALSE);
					GlobalError_SET (ERR_Output_HighVoltage);		
				}
			}
		}
		
		if (OUT_ON_R_Read() != 0) {
			if (WorkMode_ModeGET == WM_CurrStab) {
				StabilizeCurrent (200, PowerUnit.CurrentSP);
			} else if (WorkMode_ModeGET == WM_BatteryChrg) {
				fl = GetBatteryChargeLevel();
				if (fl >= 99) { //если осталось зарядить 1%
					StabilizeCurrent (100, PowerUnit.CurrentSP * 0.05);  //то установить 5% тока заряда
				} else if (fl >= 97) { //если осталось зарядить 3%
					StabilizeCurrent (100, PowerUnit.CurrentSP * 0.1);  //то установить 10% тока заряда
				} else if (fl >= 95) { //если осталось зарядить 5%
					StabilizeCurrent (100, PowerUnit.CurrentSP * 0.5);  //то установить 50% тока заряда
				} else if (fl >= 90) { //если осталось зарядить 10%
					StabilizeCurrent (100, PowerUnit.CurrentSP * 0.8);  //то установить 80% тока заряда
				} else { 
					StabilizeCurrent (100, PowerUnit.CurrentSP);  
				}
			}
		} else if ((WorkMode_ModeGET == WM_CurrStab) || (WorkMode_ModeGET == WM_BatteryChrg)) {
			ResetStabilizeCurrentVDACValue();
		}
		
		if (PowerUnit.VoltageMeasNew) {
			VoltageMeasPrev = PowerUnit.VoltageMeas;
			PowerUnit.VoltageMeasNew = FALSE;
		}
		
		
    LEDDisplay_ShowMeasured();
		
		if (WorkMode_ModeGET == WM_VoltStab) {  /*Режим стабилизации напряжения*/
			LEDDisplay_ShowBarInVoltStab();			
		} else if (WorkMode_ModeGET == WM_CurrStab) {  /*Режим стабилизации тока*/	
			LEDDisplay_ShowBarInCurrStab();
			if (PowerUnit.WorkMode & WM_ModeChange)	ResetStabilizeCurrentVDACValue();
		} else if (WorkMode_ModeGET == WM_BatteryChrg) {  /*Режим зарядного устройства*/
			LEDDisplay_ShowBarInBatteryChrg();			
		}    
		
		if (PowerUnit.WorkMode & WM_ModeChange) {			
			PowerUnit.WorkMode &= ~WM_ModeChange;		
			if (WorkMode_ModeGET == WM_BatteryChrg)	{
				OutputDischargeOFF();
			}	else {
				OutputDischargeON();
			}
		}
		if ((CheckKeyPressed(KEY_POWER)) == 0) {
			GlbStateStore();
			WorkMode_ModeSET(WM_PowerOFF);
		} 
	} 
}

void HwPrSupress(bool AOn) {
	if (AOn) {
		HwPrNoOverCurrent_ON();
		HwPrNoOverVoltage_ON();	
		PowerUnit.HwPrSupressed = TRUE;
		LED_HwPrSupressON();	
	} else {
		if (PowerUnit.HwPrSupressed) {
			HwPrErrorClr();
			HwPrNoOverCurrent_OFF();
			HwPrNoOverVoltage_OFF();
		}
		PowerUnit.HwPrSupressed = FALSE;
		LED_HwPrSupressOFF();
	}
}


