/*******************************************************************************
* File Name: CtrlVolt12.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CtrlVolt12_H) /* Pins CtrlVolt12_H */
#define CY_PINS_CtrlVolt12_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "CtrlVolt12_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    CtrlVolt12_Write(uint8 value) ;
void    CtrlVolt12_SetDriveMode(uint8 mode) ;
uint8   CtrlVolt12_ReadDataReg(void) ;
uint8   CtrlVolt12_Read(void) ;
uint8   CtrlVolt12_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define CtrlVolt12_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define CtrlVolt12_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define CtrlVolt12_DM_RES_UP          PIN_DM_RES_UP
#define CtrlVolt12_DM_RES_DWN         PIN_DM_RES_DWN
#define CtrlVolt12_DM_OD_LO           PIN_DM_OD_LO
#define CtrlVolt12_DM_OD_HI           PIN_DM_OD_HI
#define CtrlVolt12_DM_STRONG          PIN_DM_STRONG
#define CtrlVolt12_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define CtrlVolt12_MASK               CtrlVolt12__MASK
#define CtrlVolt12_SHIFT              CtrlVolt12__SHIFT
#define CtrlVolt12_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CtrlVolt12_PS                     (* (reg8 *) CtrlVolt12__PS)
/* Data Register */
#define CtrlVolt12_DR                     (* (reg8 *) CtrlVolt12__DR)
/* Port Number */
#define CtrlVolt12_PRT_NUM                (* (reg8 *) CtrlVolt12__PRT) 
/* Connect to Analog Globals */                                                  
#define CtrlVolt12_AG                     (* (reg8 *) CtrlVolt12__AG)                       
/* Analog MUX bux enable */
#define CtrlVolt12_AMUX                   (* (reg8 *) CtrlVolt12__AMUX) 
/* Bidirectional Enable */                                                        
#define CtrlVolt12_BIE                    (* (reg8 *) CtrlVolt12__BIE)
/* Bit-mask for Aliased Register Access */
#define CtrlVolt12_BIT_MASK               (* (reg8 *) CtrlVolt12__BIT_MASK)
/* Bypass Enable */
#define CtrlVolt12_BYP                    (* (reg8 *) CtrlVolt12__BYP)
/* Port wide control signals */                                                   
#define CtrlVolt12_CTL                    (* (reg8 *) CtrlVolt12__CTL)
/* Drive Modes */
#define CtrlVolt12_DM0                    (* (reg8 *) CtrlVolt12__DM0) 
#define CtrlVolt12_DM1                    (* (reg8 *) CtrlVolt12__DM1)
#define CtrlVolt12_DM2                    (* (reg8 *) CtrlVolt12__DM2) 
/* Input Buffer Disable Override */
#define CtrlVolt12_INP_DIS                (* (reg8 *) CtrlVolt12__INP_DIS)
/* LCD Common or Segment Drive */
#define CtrlVolt12_LCD_COM_SEG            (* (reg8 *) CtrlVolt12__LCD_COM_SEG)
/* Enable Segment LCD */
#define CtrlVolt12_LCD_EN                 (* (reg8 *) CtrlVolt12__LCD_EN)
/* Slew Rate Control */
#define CtrlVolt12_SLW                    (* (reg8 *) CtrlVolt12__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define CtrlVolt12_PRTDSI__CAPS_SEL       (* (reg8 *) CtrlVolt12__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define CtrlVolt12_PRTDSI__DBL_SYNC_IN    (* (reg8 *) CtrlVolt12__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define CtrlVolt12_PRTDSI__OE_SEL0        (* (reg8 *) CtrlVolt12__PRTDSI__OE_SEL0) 
#define CtrlVolt12_PRTDSI__OE_SEL1        (* (reg8 *) CtrlVolt12__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define CtrlVolt12_PRTDSI__OUT_SEL0       (* (reg8 *) CtrlVolt12__PRTDSI__OUT_SEL0) 
#define CtrlVolt12_PRTDSI__OUT_SEL1       (* (reg8 *) CtrlVolt12__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define CtrlVolt12_PRTDSI__SYNC_OUT       (* (reg8 *) CtrlVolt12__PRTDSI__SYNC_OUT) 


#if defined(CtrlVolt12__INTSTAT)  /* Interrupt Registers */

    #define CtrlVolt12_INTSTAT                (* (reg8 *) CtrlVolt12__INTSTAT)
    #define CtrlVolt12_SNAP                   (* (reg8 *) CtrlVolt12__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins CtrlVolt12_H */


/* [] END OF FILE */
