/*******************************************************************************
* File Name: CtrlVolt24.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_CtrlVolt24_H) /* Pins CtrlVolt24_H */
#define CY_PINS_CtrlVolt24_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "CtrlVolt24_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    CtrlVolt24_Write(uint8 value) ;
void    CtrlVolt24_SetDriveMode(uint8 mode) ;
uint8   CtrlVolt24_ReadDataReg(void) ;
uint8   CtrlVolt24_Read(void) ;
uint8   CtrlVolt24_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define CtrlVolt24_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define CtrlVolt24_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define CtrlVolt24_DM_RES_UP          PIN_DM_RES_UP
#define CtrlVolt24_DM_RES_DWN         PIN_DM_RES_DWN
#define CtrlVolt24_DM_OD_LO           PIN_DM_OD_LO
#define CtrlVolt24_DM_OD_HI           PIN_DM_OD_HI
#define CtrlVolt24_DM_STRONG          PIN_DM_STRONG
#define CtrlVolt24_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define CtrlVolt24_MASK               CtrlVolt24__MASK
#define CtrlVolt24_SHIFT              CtrlVolt24__SHIFT
#define CtrlVolt24_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define CtrlVolt24_PS                     (* (reg8 *) CtrlVolt24__PS)
/* Data Register */
#define CtrlVolt24_DR                     (* (reg8 *) CtrlVolt24__DR)
/* Port Number */
#define CtrlVolt24_PRT_NUM                (* (reg8 *) CtrlVolt24__PRT) 
/* Connect to Analog Globals */                                                  
#define CtrlVolt24_AG                     (* (reg8 *) CtrlVolt24__AG)                       
/* Analog MUX bux enable */
#define CtrlVolt24_AMUX                   (* (reg8 *) CtrlVolt24__AMUX) 
/* Bidirectional Enable */                                                        
#define CtrlVolt24_BIE                    (* (reg8 *) CtrlVolt24__BIE)
/* Bit-mask for Aliased Register Access */
#define CtrlVolt24_BIT_MASK               (* (reg8 *) CtrlVolt24__BIT_MASK)
/* Bypass Enable */
#define CtrlVolt24_BYP                    (* (reg8 *) CtrlVolt24__BYP)
/* Port wide control signals */                                                   
#define CtrlVolt24_CTL                    (* (reg8 *) CtrlVolt24__CTL)
/* Drive Modes */
#define CtrlVolt24_DM0                    (* (reg8 *) CtrlVolt24__DM0) 
#define CtrlVolt24_DM1                    (* (reg8 *) CtrlVolt24__DM1)
#define CtrlVolt24_DM2                    (* (reg8 *) CtrlVolt24__DM2) 
/* Input Buffer Disable Override */
#define CtrlVolt24_INP_DIS                (* (reg8 *) CtrlVolt24__INP_DIS)
/* LCD Common or Segment Drive */
#define CtrlVolt24_LCD_COM_SEG            (* (reg8 *) CtrlVolt24__LCD_COM_SEG)
/* Enable Segment LCD */
#define CtrlVolt24_LCD_EN                 (* (reg8 *) CtrlVolt24__LCD_EN)
/* Slew Rate Control */
#define CtrlVolt24_SLW                    (* (reg8 *) CtrlVolt24__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define CtrlVolt24_PRTDSI__CAPS_SEL       (* (reg8 *) CtrlVolt24__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define CtrlVolt24_PRTDSI__DBL_SYNC_IN    (* (reg8 *) CtrlVolt24__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define CtrlVolt24_PRTDSI__OE_SEL0        (* (reg8 *) CtrlVolt24__PRTDSI__OE_SEL0) 
#define CtrlVolt24_PRTDSI__OE_SEL1        (* (reg8 *) CtrlVolt24__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define CtrlVolt24_PRTDSI__OUT_SEL0       (* (reg8 *) CtrlVolt24__PRTDSI__OUT_SEL0) 
#define CtrlVolt24_PRTDSI__OUT_SEL1       (* (reg8 *) CtrlVolt24__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define CtrlVolt24_PRTDSI__SYNC_OUT       (* (reg8 *) CtrlVolt24__PRTDSI__SYNC_OUT) 


#if defined(CtrlVolt24__INTSTAT)  /* Interrupt Registers */

    #define CtrlVolt24_INTSTAT                (* (reg8 *) CtrlVolt24__INTSTAT)
    #define CtrlVolt24_SNAP                   (* (reg8 *) CtrlVolt24__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins CtrlVolt24_H */


/* [] END OF FILE */
