/*******************************************************************************
* File Name: FAN_TCH.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_FAN_TCH_H) /* Pins FAN_TCH_H */
#define CY_PINS_FAN_TCH_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "FAN_TCH_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    FAN_TCH_Write(uint8 value) ;
void    FAN_TCH_SetDriveMode(uint8 mode) ;
uint8   FAN_TCH_ReadDataReg(void) ;
uint8   FAN_TCH_Read(void) ;
uint8   FAN_TCH_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define FAN_TCH_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define FAN_TCH_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define FAN_TCH_DM_RES_UP          PIN_DM_RES_UP
#define FAN_TCH_DM_RES_DWN         PIN_DM_RES_DWN
#define FAN_TCH_DM_OD_LO           PIN_DM_OD_LO
#define FAN_TCH_DM_OD_HI           PIN_DM_OD_HI
#define FAN_TCH_DM_STRONG          PIN_DM_STRONG
#define FAN_TCH_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define FAN_TCH_MASK               FAN_TCH__MASK
#define FAN_TCH_SHIFT              FAN_TCH__SHIFT
#define FAN_TCH_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define FAN_TCH_PS                     (* (reg8 *) FAN_TCH__PS)
/* Data Register */
#define FAN_TCH_DR                     (* (reg8 *) FAN_TCH__DR)
/* Port Number */
#define FAN_TCH_PRT_NUM                (* (reg8 *) FAN_TCH__PRT) 
/* Connect to Analog Globals */                                                  
#define FAN_TCH_AG                     (* (reg8 *) FAN_TCH__AG)                       
/* Analog MUX bux enable */
#define FAN_TCH_AMUX                   (* (reg8 *) FAN_TCH__AMUX) 
/* Bidirectional Enable */                                                        
#define FAN_TCH_BIE                    (* (reg8 *) FAN_TCH__BIE)
/* Bit-mask for Aliased Register Access */
#define FAN_TCH_BIT_MASK               (* (reg8 *) FAN_TCH__BIT_MASK)
/* Bypass Enable */
#define FAN_TCH_BYP                    (* (reg8 *) FAN_TCH__BYP)
/* Port wide control signals */                                                   
#define FAN_TCH_CTL                    (* (reg8 *) FAN_TCH__CTL)
/* Drive Modes */
#define FAN_TCH_DM0                    (* (reg8 *) FAN_TCH__DM0) 
#define FAN_TCH_DM1                    (* (reg8 *) FAN_TCH__DM1)
#define FAN_TCH_DM2                    (* (reg8 *) FAN_TCH__DM2) 
/* Input Buffer Disable Override */
#define FAN_TCH_INP_DIS                (* (reg8 *) FAN_TCH__INP_DIS)
/* LCD Common or Segment Drive */
#define FAN_TCH_LCD_COM_SEG            (* (reg8 *) FAN_TCH__LCD_COM_SEG)
/* Enable Segment LCD */
#define FAN_TCH_LCD_EN                 (* (reg8 *) FAN_TCH__LCD_EN)
/* Slew Rate Control */
#define FAN_TCH_SLW                    (* (reg8 *) FAN_TCH__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define FAN_TCH_PRTDSI__CAPS_SEL       (* (reg8 *) FAN_TCH__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define FAN_TCH_PRTDSI__DBL_SYNC_IN    (* (reg8 *) FAN_TCH__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define FAN_TCH_PRTDSI__OE_SEL0        (* (reg8 *) FAN_TCH__PRTDSI__OE_SEL0) 
#define FAN_TCH_PRTDSI__OE_SEL1        (* (reg8 *) FAN_TCH__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define FAN_TCH_PRTDSI__OUT_SEL0       (* (reg8 *) FAN_TCH__PRTDSI__OUT_SEL0) 
#define FAN_TCH_PRTDSI__OUT_SEL1       (* (reg8 *) FAN_TCH__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define FAN_TCH_PRTDSI__SYNC_OUT       (* (reg8 *) FAN_TCH__PRTDSI__SYNC_OUT) 


#if defined(FAN_TCH__INTSTAT)  /* Interrupt Registers */

    #define FAN_TCH_INTSTAT                (* (reg8 *) FAN_TCH__INTSTAT)
    #define FAN_TCH_SNAP                   (* (reg8 *) FAN_TCH__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins FAN_TCH_H */


/* [] END OF FILE */
