/*******************************************************************************
* File Name: Key.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_Key_H) /* Pins Key_H */
#define CY_PINS_Key_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "Key_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    Key_Write(uint8 value) ;
void    Key_SetDriveMode(uint8 mode) ;
uint8   Key_ReadDataReg(void) ;
uint8   Key_Read(void) ;
uint8   Key_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define Key_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define Key_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define Key_DM_RES_UP          PIN_DM_RES_UP
#define Key_DM_RES_DWN         PIN_DM_RES_DWN
#define Key_DM_OD_LO           PIN_DM_OD_LO
#define Key_DM_OD_HI           PIN_DM_OD_HI
#define Key_DM_STRONG          PIN_DM_STRONG
#define Key_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define Key_MASK               Key__MASK
#define Key_SHIFT              Key__SHIFT
#define Key_WIDTH              6u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define Key_PS                     (* (reg8 *) Key__PS)
/* Data Register */
#define Key_DR                     (* (reg8 *) Key__DR)
/* Port Number */
#define Key_PRT_NUM                (* (reg8 *) Key__PRT) 
/* Connect to Analog Globals */                                                  
#define Key_AG                     (* (reg8 *) Key__AG)                       
/* Analog MUX bux enable */
#define Key_AMUX                   (* (reg8 *) Key__AMUX) 
/* Bidirectional Enable */                                                        
#define Key_BIE                    (* (reg8 *) Key__BIE)
/* Bit-mask for Aliased Register Access */
#define Key_BIT_MASK               (* (reg8 *) Key__BIT_MASK)
/* Bypass Enable */
#define Key_BYP                    (* (reg8 *) Key__BYP)
/* Port wide control signals */                                                   
#define Key_CTL                    (* (reg8 *) Key__CTL)
/* Drive Modes */
#define Key_DM0                    (* (reg8 *) Key__DM0) 
#define Key_DM1                    (* (reg8 *) Key__DM1)
#define Key_DM2                    (* (reg8 *) Key__DM2) 
/* Input Buffer Disable Override */
#define Key_INP_DIS                (* (reg8 *) Key__INP_DIS)
/* LCD Common or Segment Drive */
#define Key_LCD_COM_SEG            (* (reg8 *) Key__LCD_COM_SEG)
/* Enable Segment LCD */
#define Key_LCD_EN                 (* (reg8 *) Key__LCD_EN)
/* Slew Rate Control */
#define Key_SLW                    (* (reg8 *) Key__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define Key_PRTDSI__CAPS_SEL       (* (reg8 *) Key__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define Key_PRTDSI__DBL_SYNC_IN    (* (reg8 *) Key__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define Key_PRTDSI__OE_SEL0        (* (reg8 *) Key__PRTDSI__OE_SEL0) 
#define Key_PRTDSI__OE_SEL1        (* (reg8 *) Key__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define Key_PRTDSI__OUT_SEL0       (* (reg8 *) Key__PRTDSI__OUT_SEL0) 
#define Key_PRTDSI__OUT_SEL1       (* (reg8 *) Key__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define Key_PRTDSI__SYNC_OUT       (* (reg8 *) Key__PRTDSI__SYNC_OUT) 


#if defined(Key__INTSTAT)  /* Interrupt Registers */

    #define Key_INTSTAT                (* (reg8 *) Key__INTSTAT)
    #define Key_SNAP                   (* (reg8 *) Key__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins Key_H */


/* [] END OF FILE */
