/*******************************************************************************
* File Name: KeyStatus.h  
* Version 1.80
*
* Description:
*  This file containts Status Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_STATUS_REG_KeyStatus_H) /* CY_STATUS_REG_KeyStatus_H */
#define CY_STATUS_REG_KeyStatus_H

#include "cytypes.h"
#include "CyLib.h"


/***************************************
*        Function Prototypes
***************************************/

uint8 KeyStatus_Read(void) ;
void KeyStatus_InterruptEnable(void) ;
void KeyStatus_InterruptDisable(void) ;
void KeyStatus_WriteMask(uint8 mask) ;
uint8 KeyStatus_ReadMask(void) ;


/***************************************
*           API Constants
***************************************/

#define KeyStatus_STATUS_INTR_ENBL    0x10u


/***************************************
*         Parameter Constants
***************************************/

/* Status Register Inputs */
#define KeyStatus_INPUTS              6


/***************************************
*             Registers
***************************************/

/* Status Register */
#define KeyStatus_Status             (* (reg8 *) KeyStatus_sts_sts_reg__STATUS_REG )
#define KeyStatus_Status_PTR         (  (reg8 *) KeyStatus_sts_sts_reg__STATUS_REG )
#define KeyStatus_Status_Mask        (* (reg8 *) KeyStatus_sts_sts_reg__MASK_REG )
#define KeyStatus_Status_Aux_Ctrl    (* (reg8 *) KeyStatus_sts_sts_reg__STATUS_AUX_CTL_REG )

#endif /* End CY_STATUS_REG_KeyStatus_H */


/* [] END OF FILE */
