/*******************************************************************************
* File Name: MAIN_PWR.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_MAIN_PWR_H) /* Pins MAIN_PWR_H */
#define CY_PINS_MAIN_PWR_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "MAIN_PWR_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    MAIN_PWR_Write(uint8 value) ;
void    MAIN_PWR_SetDriveMode(uint8 mode) ;
uint8   MAIN_PWR_ReadDataReg(void) ;
uint8   MAIN_PWR_Read(void) ;
uint8   MAIN_PWR_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define MAIN_PWR_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define MAIN_PWR_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define MAIN_PWR_DM_RES_UP          PIN_DM_RES_UP
#define MAIN_PWR_DM_RES_DWN         PIN_DM_RES_DWN
#define MAIN_PWR_DM_OD_LO           PIN_DM_OD_LO
#define MAIN_PWR_DM_OD_HI           PIN_DM_OD_HI
#define MAIN_PWR_DM_STRONG          PIN_DM_STRONG
#define MAIN_PWR_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define MAIN_PWR_MASK               MAIN_PWR__MASK
#define MAIN_PWR_SHIFT              MAIN_PWR__SHIFT
#define MAIN_PWR_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define MAIN_PWR_PS                     (* (reg8 *) MAIN_PWR__PS)
/* Data Register */
#define MAIN_PWR_DR                     (* (reg8 *) MAIN_PWR__DR)
/* Port Number */
#define MAIN_PWR_PRT_NUM                (* (reg8 *) MAIN_PWR__PRT) 
/* Connect to Analog Globals */                                                  
#define MAIN_PWR_AG                     (* (reg8 *) MAIN_PWR__AG)                       
/* Analog MUX bux enable */
#define MAIN_PWR_AMUX                   (* (reg8 *) MAIN_PWR__AMUX) 
/* Bidirectional Enable */                                                        
#define MAIN_PWR_BIE                    (* (reg8 *) MAIN_PWR__BIE)
/* Bit-mask for Aliased Register Access */
#define MAIN_PWR_BIT_MASK               (* (reg8 *) MAIN_PWR__BIT_MASK)
/* Bypass Enable */
#define MAIN_PWR_BYP                    (* (reg8 *) MAIN_PWR__BYP)
/* Port wide control signals */                                                   
#define MAIN_PWR_CTL                    (* (reg8 *) MAIN_PWR__CTL)
/* Drive Modes */
#define MAIN_PWR_DM0                    (* (reg8 *) MAIN_PWR__DM0) 
#define MAIN_PWR_DM1                    (* (reg8 *) MAIN_PWR__DM1)
#define MAIN_PWR_DM2                    (* (reg8 *) MAIN_PWR__DM2) 
/* Input Buffer Disable Override */
#define MAIN_PWR_INP_DIS                (* (reg8 *) MAIN_PWR__INP_DIS)
/* LCD Common or Segment Drive */
#define MAIN_PWR_LCD_COM_SEG            (* (reg8 *) MAIN_PWR__LCD_COM_SEG)
/* Enable Segment LCD */
#define MAIN_PWR_LCD_EN                 (* (reg8 *) MAIN_PWR__LCD_EN)
/* Slew Rate Control */
#define MAIN_PWR_SLW                    (* (reg8 *) MAIN_PWR__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define MAIN_PWR_PRTDSI__CAPS_SEL       (* (reg8 *) MAIN_PWR__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define MAIN_PWR_PRTDSI__DBL_SYNC_IN    (* (reg8 *) MAIN_PWR__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define MAIN_PWR_PRTDSI__OE_SEL0        (* (reg8 *) MAIN_PWR__PRTDSI__OE_SEL0) 
#define MAIN_PWR_PRTDSI__OE_SEL1        (* (reg8 *) MAIN_PWR__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define MAIN_PWR_PRTDSI__OUT_SEL0       (* (reg8 *) MAIN_PWR__PRTDSI__OUT_SEL0) 
#define MAIN_PWR_PRTDSI__OUT_SEL1       (* (reg8 *) MAIN_PWR__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define MAIN_PWR_PRTDSI__SYNC_OUT       (* (reg8 *) MAIN_PWR__PRTDSI__SYNC_OUT) 


#if defined(MAIN_PWR__INTSTAT)  /* Interrupt Registers */

    #define MAIN_PWR_INTSTAT                (* (reg8 *) MAIN_PWR__INTSTAT)
    #define MAIN_PWR_SNAP                   (* (reg8 *) MAIN_PWR__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins MAIN_PWR_H */


/* [] END OF FILE */
