/*******************************************************************************
* File Name: MeasAC.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_MeasAC_H) /* Pins MeasAC_H */
#define CY_PINS_MeasAC_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "MeasAC_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    MeasAC_Write(uint8 value) ;
void    MeasAC_SetDriveMode(uint8 mode) ;
uint8   MeasAC_ReadDataReg(void) ;
uint8   MeasAC_Read(void) ;
uint8   MeasAC_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define MeasAC_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define MeasAC_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define MeasAC_DM_RES_UP          PIN_DM_RES_UP
#define MeasAC_DM_RES_DWN         PIN_DM_RES_DWN
#define MeasAC_DM_OD_LO           PIN_DM_OD_LO
#define MeasAC_DM_OD_HI           PIN_DM_OD_HI
#define MeasAC_DM_STRONG          PIN_DM_STRONG
#define MeasAC_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define MeasAC_MASK               MeasAC__MASK
#define MeasAC_SHIFT              MeasAC__SHIFT
#define MeasAC_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define MeasAC_PS                     (* (reg8 *) MeasAC__PS)
/* Data Register */
#define MeasAC_DR                     (* (reg8 *) MeasAC__DR)
/* Port Number */
#define MeasAC_PRT_NUM                (* (reg8 *) MeasAC__PRT) 
/* Connect to Analog Globals */                                                  
#define MeasAC_AG                     (* (reg8 *) MeasAC__AG)                       
/* Analog MUX bux enable */
#define MeasAC_AMUX                   (* (reg8 *) MeasAC__AMUX) 
/* Bidirectional Enable */                                                        
#define MeasAC_BIE                    (* (reg8 *) MeasAC__BIE)
/* Bit-mask for Aliased Register Access */
#define MeasAC_BIT_MASK               (* (reg8 *) MeasAC__BIT_MASK)
/* Bypass Enable */
#define MeasAC_BYP                    (* (reg8 *) MeasAC__BYP)
/* Port wide control signals */                                                   
#define MeasAC_CTL                    (* (reg8 *) MeasAC__CTL)
/* Drive Modes */
#define MeasAC_DM0                    (* (reg8 *) MeasAC__DM0) 
#define MeasAC_DM1                    (* (reg8 *) MeasAC__DM1)
#define MeasAC_DM2                    (* (reg8 *) MeasAC__DM2) 
/* Input Buffer Disable Override */
#define MeasAC_INP_DIS                (* (reg8 *) MeasAC__INP_DIS)
/* LCD Common or Segment Drive */
#define MeasAC_LCD_COM_SEG            (* (reg8 *) MeasAC__LCD_COM_SEG)
/* Enable Segment LCD */
#define MeasAC_LCD_EN                 (* (reg8 *) MeasAC__LCD_EN)
/* Slew Rate Control */
#define MeasAC_SLW                    (* (reg8 *) MeasAC__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define MeasAC_PRTDSI__CAPS_SEL       (* (reg8 *) MeasAC__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define MeasAC_PRTDSI__DBL_SYNC_IN    (* (reg8 *) MeasAC__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define MeasAC_PRTDSI__OE_SEL0        (* (reg8 *) MeasAC__PRTDSI__OE_SEL0) 
#define MeasAC_PRTDSI__OE_SEL1        (* (reg8 *) MeasAC__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define MeasAC_PRTDSI__OUT_SEL0       (* (reg8 *) MeasAC__PRTDSI__OUT_SEL0) 
#define MeasAC_PRTDSI__OUT_SEL1       (* (reg8 *) MeasAC__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define MeasAC_PRTDSI__SYNC_OUT       (* (reg8 *) MeasAC__PRTDSI__SYNC_OUT) 


#if defined(MeasAC__INTSTAT)  /* Interrupt Registers */

    #define MeasAC_INTSTAT                (* (reg8 *) MeasAC__INTSTAT)
    #define MeasAC_SNAP                   (* (reg8 *) MeasAC__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins MeasAC_H */


/* [] END OF FILE */
