/*******************************************************************************
* File Name: MouseClk.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_MouseClk_H) /* Pins MouseClk_H */
#define CY_PINS_MouseClk_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "MouseClk_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    MouseClk_Write(uint8 value) ;
void    MouseClk_SetDriveMode(uint8 mode) ;
uint8   MouseClk_ReadDataReg(void) ;
uint8   MouseClk_Read(void) ;
uint8   MouseClk_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define MouseClk_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define MouseClk_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define MouseClk_DM_RES_UP          PIN_DM_RES_UP
#define MouseClk_DM_RES_DWN         PIN_DM_RES_DWN
#define MouseClk_DM_OD_LO           PIN_DM_OD_LO
#define MouseClk_DM_OD_HI           PIN_DM_OD_HI
#define MouseClk_DM_STRONG          PIN_DM_STRONG
#define MouseClk_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define MouseClk_MASK               MouseClk__MASK
#define MouseClk_SHIFT              MouseClk__SHIFT
#define MouseClk_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define MouseClk_PS                     (* (reg8 *) MouseClk__PS)
/* Data Register */
#define MouseClk_DR                     (* (reg8 *) MouseClk__DR)
/* Port Number */
#define MouseClk_PRT_NUM                (* (reg8 *) MouseClk__PRT) 
/* Connect to Analog Globals */                                                  
#define MouseClk_AG                     (* (reg8 *) MouseClk__AG)                       
/* Analog MUX bux enable */
#define MouseClk_AMUX                   (* (reg8 *) MouseClk__AMUX) 
/* Bidirectional Enable */                                                        
#define MouseClk_BIE                    (* (reg8 *) MouseClk__BIE)
/* Bit-mask for Aliased Register Access */
#define MouseClk_BIT_MASK               (* (reg8 *) MouseClk__BIT_MASK)
/* Bypass Enable */
#define MouseClk_BYP                    (* (reg8 *) MouseClk__BYP)
/* Port wide control signals */                                                   
#define MouseClk_CTL                    (* (reg8 *) MouseClk__CTL)
/* Drive Modes */
#define MouseClk_DM0                    (* (reg8 *) MouseClk__DM0) 
#define MouseClk_DM1                    (* (reg8 *) MouseClk__DM1)
#define MouseClk_DM2                    (* (reg8 *) MouseClk__DM2) 
/* Input Buffer Disable Override */
#define MouseClk_INP_DIS                (* (reg8 *) MouseClk__INP_DIS)
/* LCD Common or Segment Drive */
#define MouseClk_LCD_COM_SEG            (* (reg8 *) MouseClk__LCD_COM_SEG)
/* Enable Segment LCD */
#define MouseClk_LCD_EN                 (* (reg8 *) MouseClk__LCD_EN)
/* Slew Rate Control */
#define MouseClk_SLW                    (* (reg8 *) MouseClk__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define MouseClk_PRTDSI__CAPS_SEL       (* (reg8 *) MouseClk__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define MouseClk_PRTDSI__DBL_SYNC_IN    (* (reg8 *) MouseClk__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define MouseClk_PRTDSI__OE_SEL0        (* (reg8 *) MouseClk__PRTDSI__OE_SEL0) 
#define MouseClk_PRTDSI__OE_SEL1        (* (reg8 *) MouseClk__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define MouseClk_PRTDSI__OUT_SEL0       (* (reg8 *) MouseClk__PRTDSI__OUT_SEL0) 
#define MouseClk_PRTDSI__OUT_SEL1       (* (reg8 *) MouseClk__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define MouseClk_PRTDSI__SYNC_OUT       (* (reg8 *) MouseClk__PRTDSI__SYNC_OUT) 


#if defined(MouseClk__INTSTAT)  /* Interrupt Registers */

    #define MouseClk_INTSTAT                (* (reg8 *) MouseClk__INTSTAT)
    #define MouseClk_SNAP                   (* (reg8 *) MouseClk__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins MouseClk_H */


/* [] END OF FILE */
