/*******************************************************************************
* File Name: MouseData.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_MouseData_H) /* Pins MouseData_H */
#define CY_PINS_MouseData_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "MouseData_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    MouseData_Write(uint8 value) ;
void    MouseData_SetDriveMode(uint8 mode) ;
uint8   MouseData_ReadDataReg(void) ;
uint8   MouseData_Read(void) ;
uint8   MouseData_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define MouseData_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define MouseData_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define MouseData_DM_RES_UP          PIN_DM_RES_UP
#define MouseData_DM_RES_DWN         PIN_DM_RES_DWN
#define MouseData_DM_OD_LO           PIN_DM_OD_LO
#define MouseData_DM_OD_HI           PIN_DM_OD_HI
#define MouseData_DM_STRONG          PIN_DM_STRONG
#define MouseData_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define MouseData_MASK               MouseData__MASK
#define MouseData_SHIFT              MouseData__SHIFT
#define MouseData_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define MouseData_PS                     (* (reg8 *) MouseData__PS)
/* Data Register */
#define MouseData_DR                     (* (reg8 *) MouseData__DR)
/* Port Number */
#define MouseData_PRT_NUM                (* (reg8 *) MouseData__PRT) 
/* Connect to Analog Globals */                                                  
#define MouseData_AG                     (* (reg8 *) MouseData__AG)                       
/* Analog MUX bux enable */
#define MouseData_AMUX                   (* (reg8 *) MouseData__AMUX) 
/* Bidirectional Enable */                                                        
#define MouseData_BIE                    (* (reg8 *) MouseData__BIE)
/* Bit-mask for Aliased Register Access */
#define MouseData_BIT_MASK               (* (reg8 *) MouseData__BIT_MASK)
/* Bypass Enable */
#define MouseData_BYP                    (* (reg8 *) MouseData__BYP)
/* Port wide control signals */                                                   
#define MouseData_CTL                    (* (reg8 *) MouseData__CTL)
/* Drive Modes */
#define MouseData_DM0                    (* (reg8 *) MouseData__DM0) 
#define MouseData_DM1                    (* (reg8 *) MouseData__DM1)
#define MouseData_DM2                    (* (reg8 *) MouseData__DM2) 
/* Input Buffer Disable Override */
#define MouseData_INP_DIS                (* (reg8 *) MouseData__INP_DIS)
/* LCD Common or Segment Drive */
#define MouseData_LCD_COM_SEG            (* (reg8 *) MouseData__LCD_COM_SEG)
/* Enable Segment LCD */
#define MouseData_LCD_EN                 (* (reg8 *) MouseData__LCD_EN)
/* Slew Rate Control */
#define MouseData_SLW                    (* (reg8 *) MouseData__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define MouseData_PRTDSI__CAPS_SEL       (* (reg8 *) MouseData__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define MouseData_PRTDSI__DBL_SYNC_IN    (* (reg8 *) MouseData__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define MouseData_PRTDSI__OE_SEL0        (* (reg8 *) MouseData__PRTDSI__OE_SEL0) 
#define MouseData_PRTDSI__OE_SEL1        (* (reg8 *) MouseData__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define MouseData_PRTDSI__OUT_SEL0       (* (reg8 *) MouseData__PRTDSI__OUT_SEL0) 
#define MouseData_PRTDSI__OUT_SEL1       (* (reg8 *) MouseData__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define MouseData_PRTDSI__SYNC_OUT       (* (reg8 *) MouseData__PRTDSI__SYNC_OUT) 


#if defined(MouseData__INTSTAT)  /* Interrupt Registers */

    #define MouseData_INTSTAT                (* (reg8 *) MouseData__INTSTAT)
    #define MouseData_SNAP                   (* (reg8 *) MouseData__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins MouseData_H */


/* [] END OF FILE */
