/*******************************************************************************
* File Name: MouseISR.h
* Version 1.70
*
*  Description:
*   Provides the function definitions for the Interrupt Controller.
*
*
********************************************************************************
* Copyright 2008-2012, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_ISR_MouseISR_H)
#define CY_ISR_MouseISR_H

#include <cytypes.h>
#include <cyfitter.h>

/* Interrupt Controller API. */
void MouseISR_Start(void) ;
void MouseISR_StartEx(cyisraddress address) ;
void MouseISR_Stop(void) ;

CY_ISR_PROTO(MouseISR_Interrupt);

void MouseISR_SetVector(cyisraddress address) ;
cyisraddress MouseISR_GetVector(void) ;

void MouseISR_SetPriority(uint8 priority) ;
uint8 MouseISR_GetPriority(void) ;

void MouseISR_Enable(void) ;
uint8 MouseISR_GetState(void) ;
void MouseISR_Disable(void) ;

void MouseISR_SetPending(void) ;
void MouseISR_ClearPending(void) ;


/* Interrupt Controller Constants */

/* Address of the INTC.VECT[x] register that contains the Address of the MouseISR ISR. */
#define MouseISR_INTC_VECTOR            ((reg16 *) MouseISR__INTC_VECT)

/* Address of the MouseISR ISR priority. */
#define MouseISR_INTC_PRIOR             ((reg8 *) MouseISR__INTC_PRIOR_REG)

/* Priority of the MouseISR interrupt. */
#define MouseISR_INTC_PRIOR_NUMBER      MouseISR__INTC_PRIOR_NUM

/* Address of the INTC.SET_EN[x] byte to bit enable MouseISR interrupt. */
#define MouseISR_INTC_SET_EN            ((reg8 *) MouseISR__INTC_SET_EN_REG)

/* Address of the INTC.CLR_EN[x] register to bit clear the MouseISR interrupt. */
#define MouseISR_INTC_CLR_EN            ((reg8 *) MouseISR__INTC_CLR_EN_REG)

/* Address of the INTC.SET_PD[x] register to set the MouseISR interrupt state to pending. */
#define MouseISR_INTC_SET_PD            ((reg8 *) MouseISR__INTC_SET_PD_REG)

/* Address of the INTC.CLR_PD[x] register to clear the MouseISR interrupt. */
#define MouseISR_INTC_CLR_PD            ((reg8 *) MouseISR__INTC_CLR_PD_REG)



#endif /* CY_ISR_MouseISR_H */


/* [] END OF FILE */
