/*******************************************************************************
* File Name: OUT_DISCH.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_OUT_DISCH_H) /* Pins OUT_DISCH_H */
#define CY_PINS_OUT_DISCH_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "OUT_DISCH_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    OUT_DISCH_Write(uint8 value) ;
void    OUT_DISCH_SetDriveMode(uint8 mode) ;
uint8   OUT_DISCH_ReadDataReg(void) ;
uint8   OUT_DISCH_Read(void) ;
uint8   OUT_DISCH_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define OUT_DISCH_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define OUT_DISCH_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define OUT_DISCH_DM_RES_UP          PIN_DM_RES_UP
#define OUT_DISCH_DM_RES_DWN         PIN_DM_RES_DWN
#define OUT_DISCH_DM_OD_LO           PIN_DM_OD_LO
#define OUT_DISCH_DM_OD_HI           PIN_DM_OD_HI
#define OUT_DISCH_DM_STRONG          PIN_DM_STRONG
#define OUT_DISCH_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define OUT_DISCH_MASK               OUT_DISCH__MASK
#define OUT_DISCH_SHIFT              OUT_DISCH__SHIFT
#define OUT_DISCH_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define OUT_DISCH_PS                     (* (reg8 *) OUT_DISCH__PS)
/* Data Register */
#define OUT_DISCH_DR                     (* (reg8 *) OUT_DISCH__DR)
/* Port Number */
#define OUT_DISCH_PRT_NUM                (* (reg8 *) OUT_DISCH__PRT) 
/* Connect to Analog Globals */                                                  
#define OUT_DISCH_AG                     (* (reg8 *) OUT_DISCH__AG)                       
/* Analog MUX bux enable */
#define OUT_DISCH_AMUX                   (* (reg8 *) OUT_DISCH__AMUX) 
/* Bidirectional Enable */                                                        
#define OUT_DISCH_BIE                    (* (reg8 *) OUT_DISCH__BIE)
/* Bit-mask for Aliased Register Access */
#define OUT_DISCH_BIT_MASK               (* (reg8 *) OUT_DISCH__BIT_MASK)
/* Bypass Enable */
#define OUT_DISCH_BYP                    (* (reg8 *) OUT_DISCH__BYP)
/* Port wide control signals */                                                   
#define OUT_DISCH_CTL                    (* (reg8 *) OUT_DISCH__CTL)
/* Drive Modes */
#define OUT_DISCH_DM0                    (* (reg8 *) OUT_DISCH__DM0) 
#define OUT_DISCH_DM1                    (* (reg8 *) OUT_DISCH__DM1)
#define OUT_DISCH_DM2                    (* (reg8 *) OUT_DISCH__DM2) 
/* Input Buffer Disable Override */
#define OUT_DISCH_INP_DIS                (* (reg8 *) OUT_DISCH__INP_DIS)
/* LCD Common or Segment Drive */
#define OUT_DISCH_LCD_COM_SEG            (* (reg8 *) OUT_DISCH__LCD_COM_SEG)
/* Enable Segment LCD */
#define OUT_DISCH_LCD_EN                 (* (reg8 *) OUT_DISCH__LCD_EN)
/* Slew Rate Control */
#define OUT_DISCH_SLW                    (* (reg8 *) OUT_DISCH__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define OUT_DISCH_PRTDSI__CAPS_SEL       (* (reg8 *) OUT_DISCH__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define OUT_DISCH_PRTDSI__DBL_SYNC_IN    (* (reg8 *) OUT_DISCH__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define OUT_DISCH_PRTDSI__OE_SEL0        (* (reg8 *) OUT_DISCH__PRTDSI__OE_SEL0) 
#define OUT_DISCH_PRTDSI__OE_SEL1        (* (reg8 *) OUT_DISCH__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define OUT_DISCH_PRTDSI__OUT_SEL0       (* (reg8 *) OUT_DISCH__PRTDSI__OUT_SEL0) 
#define OUT_DISCH_PRTDSI__OUT_SEL1       (* (reg8 *) OUT_DISCH__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define OUT_DISCH_PRTDSI__SYNC_OUT       (* (reg8 *) OUT_DISCH__PRTDSI__SYNC_OUT) 


#if defined(OUT_DISCH__INTSTAT)  /* Interrupt Registers */

    #define OUT_DISCH_INTSTAT                (* (reg8 *) OUT_DISCH__INTSTAT)
    #define OUT_DISCH_SNAP                   (* (reg8 *) OUT_DISCH__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins OUT_DISCH_H */


/* [] END OF FILE */
