/*******************************************************************************
* File Name: OUT_ON_R.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_OUT_ON_R_H) /* Pins OUT_ON_R_H */
#define CY_PINS_OUT_ON_R_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "OUT_ON_R_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    OUT_ON_R_Write(uint8 value) ;
void    OUT_ON_R_SetDriveMode(uint8 mode) ;
uint8   OUT_ON_R_ReadDataReg(void) ;
uint8   OUT_ON_R_Read(void) ;
uint8   OUT_ON_R_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define OUT_ON_R_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define OUT_ON_R_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define OUT_ON_R_DM_RES_UP          PIN_DM_RES_UP
#define OUT_ON_R_DM_RES_DWN         PIN_DM_RES_DWN
#define OUT_ON_R_DM_OD_LO           PIN_DM_OD_LO
#define OUT_ON_R_DM_OD_HI           PIN_DM_OD_HI
#define OUT_ON_R_DM_STRONG          PIN_DM_STRONG
#define OUT_ON_R_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define OUT_ON_R_MASK               OUT_ON_R__MASK
#define OUT_ON_R_SHIFT              OUT_ON_R__SHIFT
#define OUT_ON_R_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define OUT_ON_R_PS                     (* (reg8 *) OUT_ON_R__PS)
/* Data Register */
#define OUT_ON_R_DR                     (* (reg8 *) OUT_ON_R__DR)
/* Port Number */
#define OUT_ON_R_PRT_NUM                (* (reg8 *) OUT_ON_R__PRT) 
/* Connect to Analog Globals */                                                  
#define OUT_ON_R_AG                     (* (reg8 *) OUT_ON_R__AG)                       
/* Analog MUX bux enable */
#define OUT_ON_R_AMUX                   (* (reg8 *) OUT_ON_R__AMUX) 
/* Bidirectional Enable */                                                        
#define OUT_ON_R_BIE                    (* (reg8 *) OUT_ON_R__BIE)
/* Bit-mask for Aliased Register Access */
#define OUT_ON_R_BIT_MASK               (* (reg8 *) OUT_ON_R__BIT_MASK)
/* Bypass Enable */
#define OUT_ON_R_BYP                    (* (reg8 *) OUT_ON_R__BYP)
/* Port wide control signals */                                                   
#define OUT_ON_R_CTL                    (* (reg8 *) OUT_ON_R__CTL)
/* Drive Modes */
#define OUT_ON_R_DM0                    (* (reg8 *) OUT_ON_R__DM0) 
#define OUT_ON_R_DM1                    (* (reg8 *) OUT_ON_R__DM1)
#define OUT_ON_R_DM2                    (* (reg8 *) OUT_ON_R__DM2) 
/* Input Buffer Disable Override */
#define OUT_ON_R_INP_DIS                (* (reg8 *) OUT_ON_R__INP_DIS)
/* LCD Common or Segment Drive */
#define OUT_ON_R_LCD_COM_SEG            (* (reg8 *) OUT_ON_R__LCD_COM_SEG)
/* Enable Segment LCD */
#define OUT_ON_R_LCD_EN                 (* (reg8 *) OUT_ON_R__LCD_EN)
/* Slew Rate Control */
#define OUT_ON_R_SLW                    (* (reg8 *) OUT_ON_R__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define OUT_ON_R_PRTDSI__CAPS_SEL       (* (reg8 *) OUT_ON_R__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define OUT_ON_R_PRTDSI__DBL_SYNC_IN    (* (reg8 *) OUT_ON_R__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define OUT_ON_R_PRTDSI__OE_SEL0        (* (reg8 *) OUT_ON_R__PRTDSI__OE_SEL0) 
#define OUT_ON_R_PRTDSI__OE_SEL1        (* (reg8 *) OUT_ON_R__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define OUT_ON_R_PRTDSI__OUT_SEL0       (* (reg8 *) OUT_ON_R__PRTDSI__OUT_SEL0) 
#define OUT_ON_R_PRTDSI__OUT_SEL1       (* (reg8 *) OUT_ON_R__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define OUT_ON_R_PRTDSI__SYNC_OUT       (* (reg8 *) OUT_ON_R__PRTDSI__SYNC_OUT) 


#if defined(OUT_ON_R__INTSTAT)  /* Interrupt Registers */

    #define OUT_ON_R_INTSTAT                (* (reg8 *) OUT_ON_R__INTSTAT)
    #define OUT_ON_R_SNAP                   (* (reg8 *) OUT_ON_R__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins OUT_ON_R_H */


/* [] END OF FILE */
