/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

/* [] END OF FILE */
#include "OneWire.h"
#include <device.h>

/************************   ReadBit *******************************************/

uint8 OneWire_R_Bit() //***  Read a single bit off the 1-WIRE bus. ***
    {
        CyDelayUs(Tinact);  // Inactive before next signal........#define Tinact 20   //in us. (Inactive before next signal)
        OneWire_Pin_Write(0);       // Drive it low.                                             : http://www.cypress.com/?rID=38854&cache=0
        CyDelayUs(TMtr1);   // If its a 1 to write. ....   #define TMtr1 10    //Data bit 1 read,write 1-15us
       OneWire_Pin_Write(1);       // Back High.
	    CyDelayUs(5);       //   5??? 
	return(OneWire_Pin_Read());     //   
    //return(1);
	}
    
/**************************   WriteBit   **************************************/

void OneWire_W_Bit(uint8 payload) // Write a single bit to the 1-WIRE bus. 
    {
	    CyDelayUs(Tinact);  //Inactive before next signal.
	    OneWire_Pin_Write(0);       //Drive it low.
	        if(payload==0)		CyDelayUs(TMtr0); //If its a 0 to write.
	        else     		    CyDelayUs(TMtr1); //If its a 1 to write.
	    OneWire_Pin_Write(1);       //Back High.
    }

/*************************   Bus Reset   **************************************/
   
uint8 OneWire_BusReset() //Pulldown the required "Bus Reset". *******
    {
uint8 BusPin=0 ;       // 
        OneWire_Pin_Write(0);       // Drive it low.
	    CyDelayUs(RST_MAX); //   RESET  480 
	    OneWire_Pin_Write(1);       // Back High.
        CyDelayUs(5);       //   ..  
        if (OneWire_Pin_Read()==0x00)  	return(0xFF);   // , .
        CyDelayUs(55);      //  15-60    PRESENCE  (60-240 )
        BusPin = OneWire_Pin_Read();   //   
        CyDelayUs(200);     //     PRESENCE  (60-240) , -
return(BusPin);        //  
    }
 
/**************************   Write a byte   **********************************/
void OneWire_Write8(uint8 payload) //Write a byte to the slave.
    {
	    uint8 BitPayload,  shiftcount;
	    for (shiftcount=0; shiftcount<=7;shiftcount++) 
        {
            BitPayload = (payload >> shiftcount) & 0x01; //  LSB
            OneWire_W_Bit(BitPayload);
        }
    }  
    
/****************************   Read 8 bits  **********************************/

 uint8 OneWire_Read8() //Read 8 bits "clocked" out by the slave. 
{
	uint8 IncomingByte=0, shiftcount=0 ;
	for (shiftcount=0; shiftcount<=7; shiftcount++) 
    {
       IncomingByte |= (OneWire_R_Bit())<<shiftcount;//   LSB
    }
    return(IncomingByte);
}
   
    