/*******************************************************************************
* File Name: OutCurr_Comp.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_OutCurr_Comp_H) /* Pins OutCurr_Comp_H */
#define CY_PINS_OutCurr_Comp_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "OutCurr_Comp_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    OutCurr_Comp_Write(uint8 value) ;
void    OutCurr_Comp_SetDriveMode(uint8 mode) ;
uint8   OutCurr_Comp_ReadDataReg(void) ;
uint8   OutCurr_Comp_Read(void) ;
uint8   OutCurr_Comp_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define OutCurr_Comp_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define OutCurr_Comp_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define OutCurr_Comp_DM_RES_UP          PIN_DM_RES_UP
#define OutCurr_Comp_DM_RES_DWN         PIN_DM_RES_DWN
#define OutCurr_Comp_DM_OD_LO           PIN_DM_OD_LO
#define OutCurr_Comp_DM_OD_HI           PIN_DM_OD_HI
#define OutCurr_Comp_DM_STRONG          PIN_DM_STRONG
#define OutCurr_Comp_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define OutCurr_Comp_MASK               OutCurr_Comp__MASK
#define OutCurr_Comp_SHIFT              OutCurr_Comp__SHIFT
#define OutCurr_Comp_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define OutCurr_Comp_PS                     (* (reg8 *) OutCurr_Comp__PS)
/* Data Register */
#define OutCurr_Comp_DR                     (* (reg8 *) OutCurr_Comp__DR)
/* Port Number */
#define OutCurr_Comp_PRT_NUM                (* (reg8 *) OutCurr_Comp__PRT) 
/* Connect to Analog Globals */                                                  
#define OutCurr_Comp_AG                     (* (reg8 *) OutCurr_Comp__AG)                       
/* Analog MUX bux enable */
#define OutCurr_Comp_AMUX                   (* (reg8 *) OutCurr_Comp__AMUX) 
/* Bidirectional Enable */                                                        
#define OutCurr_Comp_BIE                    (* (reg8 *) OutCurr_Comp__BIE)
/* Bit-mask for Aliased Register Access */
#define OutCurr_Comp_BIT_MASK               (* (reg8 *) OutCurr_Comp__BIT_MASK)
/* Bypass Enable */
#define OutCurr_Comp_BYP                    (* (reg8 *) OutCurr_Comp__BYP)
/* Port wide control signals */                                                   
#define OutCurr_Comp_CTL                    (* (reg8 *) OutCurr_Comp__CTL)
/* Drive Modes */
#define OutCurr_Comp_DM0                    (* (reg8 *) OutCurr_Comp__DM0) 
#define OutCurr_Comp_DM1                    (* (reg8 *) OutCurr_Comp__DM1)
#define OutCurr_Comp_DM2                    (* (reg8 *) OutCurr_Comp__DM2) 
/* Input Buffer Disable Override */
#define OutCurr_Comp_INP_DIS                (* (reg8 *) OutCurr_Comp__INP_DIS)
/* LCD Common or Segment Drive */
#define OutCurr_Comp_LCD_COM_SEG            (* (reg8 *) OutCurr_Comp__LCD_COM_SEG)
/* Enable Segment LCD */
#define OutCurr_Comp_LCD_EN                 (* (reg8 *) OutCurr_Comp__LCD_EN)
/* Slew Rate Control */
#define OutCurr_Comp_SLW                    (* (reg8 *) OutCurr_Comp__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define OutCurr_Comp_PRTDSI__CAPS_SEL       (* (reg8 *) OutCurr_Comp__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define OutCurr_Comp_PRTDSI__DBL_SYNC_IN    (* (reg8 *) OutCurr_Comp__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define OutCurr_Comp_PRTDSI__OE_SEL0        (* (reg8 *) OutCurr_Comp__PRTDSI__OE_SEL0) 
#define OutCurr_Comp_PRTDSI__OE_SEL1        (* (reg8 *) OutCurr_Comp__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define OutCurr_Comp_PRTDSI__OUT_SEL0       (* (reg8 *) OutCurr_Comp__PRTDSI__OUT_SEL0) 
#define OutCurr_Comp_PRTDSI__OUT_SEL1       (* (reg8 *) OutCurr_Comp__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define OutCurr_Comp_PRTDSI__SYNC_OUT       (* (reg8 *) OutCurr_Comp__PRTDSI__SYNC_OUT) 


#if defined(OutCurr_Comp__INTSTAT)  /* Interrupt Registers */

    #define OutCurr_Comp_INTSTAT                (* (reg8 *) OutCurr_Comp__INTSTAT)
    #define OutCurr_Comp_SNAP                   (* (reg8 *) OutCurr_Comp__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins OutCurr_Comp_H */


/* [] END OF FILE */
