/*******************************************************************************
* File Name: OutCurr_MN.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_OutCurr_MN_H) /* Pins OutCurr_MN_H */
#define CY_PINS_OutCurr_MN_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "OutCurr_MN_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    OutCurr_MN_Write(uint8 value) ;
void    OutCurr_MN_SetDriveMode(uint8 mode) ;
uint8   OutCurr_MN_ReadDataReg(void) ;
uint8   OutCurr_MN_Read(void) ;
uint8   OutCurr_MN_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define OutCurr_MN_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define OutCurr_MN_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define OutCurr_MN_DM_RES_UP          PIN_DM_RES_UP
#define OutCurr_MN_DM_RES_DWN         PIN_DM_RES_DWN
#define OutCurr_MN_DM_OD_LO           PIN_DM_OD_LO
#define OutCurr_MN_DM_OD_HI           PIN_DM_OD_HI
#define OutCurr_MN_DM_STRONG          PIN_DM_STRONG
#define OutCurr_MN_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define OutCurr_MN_MASK               OutCurr_MN__MASK
#define OutCurr_MN_SHIFT              OutCurr_MN__SHIFT
#define OutCurr_MN_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define OutCurr_MN_PS                     (* (reg8 *) OutCurr_MN__PS)
/* Data Register */
#define OutCurr_MN_DR                     (* (reg8 *) OutCurr_MN__DR)
/* Port Number */
#define OutCurr_MN_PRT_NUM                (* (reg8 *) OutCurr_MN__PRT) 
/* Connect to Analog Globals */                                                  
#define OutCurr_MN_AG                     (* (reg8 *) OutCurr_MN__AG)                       
/* Analog MUX bux enable */
#define OutCurr_MN_AMUX                   (* (reg8 *) OutCurr_MN__AMUX) 
/* Bidirectional Enable */                                                        
#define OutCurr_MN_BIE                    (* (reg8 *) OutCurr_MN__BIE)
/* Bit-mask for Aliased Register Access */
#define OutCurr_MN_BIT_MASK               (* (reg8 *) OutCurr_MN__BIT_MASK)
/* Bypass Enable */
#define OutCurr_MN_BYP                    (* (reg8 *) OutCurr_MN__BYP)
/* Port wide control signals */                                                   
#define OutCurr_MN_CTL                    (* (reg8 *) OutCurr_MN__CTL)
/* Drive Modes */
#define OutCurr_MN_DM0                    (* (reg8 *) OutCurr_MN__DM0) 
#define OutCurr_MN_DM1                    (* (reg8 *) OutCurr_MN__DM1)
#define OutCurr_MN_DM2                    (* (reg8 *) OutCurr_MN__DM2) 
/* Input Buffer Disable Override */
#define OutCurr_MN_INP_DIS                (* (reg8 *) OutCurr_MN__INP_DIS)
/* LCD Common or Segment Drive */
#define OutCurr_MN_LCD_COM_SEG            (* (reg8 *) OutCurr_MN__LCD_COM_SEG)
/* Enable Segment LCD */
#define OutCurr_MN_LCD_EN                 (* (reg8 *) OutCurr_MN__LCD_EN)
/* Slew Rate Control */
#define OutCurr_MN_SLW                    (* (reg8 *) OutCurr_MN__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define OutCurr_MN_PRTDSI__CAPS_SEL       (* (reg8 *) OutCurr_MN__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define OutCurr_MN_PRTDSI__DBL_SYNC_IN    (* (reg8 *) OutCurr_MN__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define OutCurr_MN_PRTDSI__OE_SEL0        (* (reg8 *) OutCurr_MN__PRTDSI__OE_SEL0) 
#define OutCurr_MN_PRTDSI__OE_SEL1        (* (reg8 *) OutCurr_MN__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define OutCurr_MN_PRTDSI__OUT_SEL0       (* (reg8 *) OutCurr_MN__PRTDSI__OUT_SEL0) 
#define OutCurr_MN_PRTDSI__OUT_SEL1       (* (reg8 *) OutCurr_MN__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define OutCurr_MN_PRTDSI__SYNC_OUT       (* (reg8 *) OutCurr_MN__PRTDSI__SYNC_OUT) 


#if defined(OutCurr_MN__INTSTAT)  /* Interrupt Registers */

    #define OutCurr_MN_INTSTAT                (* (reg8 *) OutCurr_MN__INTSTAT)
    #define OutCurr_MN_SNAP                   (* (reg8 *) OutCurr_MN__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins OutCurr_MN_H */


/* [] END OF FILE */
