/*******************************************************************************
* File Name: OutVolt_PL.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_OutVolt_PL_H) /* Pins OutVolt_PL_H */
#define CY_PINS_OutVolt_PL_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "OutVolt_PL_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    OutVolt_PL_Write(uint8 value) ;
void    OutVolt_PL_SetDriveMode(uint8 mode) ;
uint8   OutVolt_PL_ReadDataReg(void) ;
uint8   OutVolt_PL_Read(void) ;
uint8   OutVolt_PL_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define OutVolt_PL_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define OutVolt_PL_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define OutVolt_PL_DM_RES_UP          PIN_DM_RES_UP
#define OutVolt_PL_DM_RES_DWN         PIN_DM_RES_DWN
#define OutVolt_PL_DM_OD_LO           PIN_DM_OD_LO
#define OutVolt_PL_DM_OD_HI           PIN_DM_OD_HI
#define OutVolt_PL_DM_STRONG          PIN_DM_STRONG
#define OutVolt_PL_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define OutVolt_PL_MASK               OutVolt_PL__MASK
#define OutVolt_PL_SHIFT              OutVolt_PL__SHIFT
#define OutVolt_PL_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define OutVolt_PL_PS                     (* (reg8 *) OutVolt_PL__PS)
/* Data Register */
#define OutVolt_PL_DR                     (* (reg8 *) OutVolt_PL__DR)
/* Port Number */
#define OutVolt_PL_PRT_NUM                (* (reg8 *) OutVolt_PL__PRT) 
/* Connect to Analog Globals */                                                  
#define OutVolt_PL_AG                     (* (reg8 *) OutVolt_PL__AG)                       
/* Analog MUX bux enable */
#define OutVolt_PL_AMUX                   (* (reg8 *) OutVolt_PL__AMUX) 
/* Bidirectional Enable */                                                        
#define OutVolt_PL_BIE                    (* (reg8 *) OutVolt_PL__BIE)
/* Bit-mask for Aliased Register Access */
#define OutVolt_PL_BIT_MASK               (* (reg8 *) OutVolt_PL__BIT_MASK)
/* Bypass Enable */
#define OutVolt_PL_BYP                    (* (reg8 *) OutVolt_PL__BYP)
/* Port wide control signals */                                                   
#define OutVolt_PL_CTL                    (* (reg8 *) OutVolt_PL__CTL)
/* Drive Modes */
#define OutVolt_PL_DM0                    (* (reg8 *) OutVolt_PL__DM0) 
#define OutVolt_PL_DM1                    (* (reg8 *) OutVolt_PL__DM1)
#define OutVolt_PL_DM2                    (* (reg8 *) OutVolt_PL__DM2) 
/* Input Buffer Disable Override */
#define OutVolt_PL_INP_DIS                (* (reg8 *) OutVolt_PL__INP_DIS)
/* LCD Common or Segment Drive */
#define OutVolt_PL_LCD_COM_SEG            (* (reg8 *) OutVolt_PL__LCD_COM_SEG)
/* Enable Segment LCD */
#define OutVolt_PL_LCD_EN                 (* (reg8 *) OutVolt_PL__LCD_EN)
/* Slew Rate Control */
#define OutVolt_PL_SLW                    (* (reg8 *) OutVolt_PL__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define OutVolt_PL_PRTDSI__CAPS_SEL       (* (reg8 *) OutVolt_PL__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define OutVolt_PL_PRTDSI__DBL_SYNC_IN    (* (reg8 *) OutVolt_PL__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define OutVolt_PL_PRTDSI__OE_SEL0        (* (reg8 *) OutVolt_PL__PRTDSI__OE_SEL0) 
#define OutVolt_PL_PRTDSI__OE_SEL1        (* (reg8 *) OutVolt_PL__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define OutVolt_PL_PRTDSI__OUT_SEL0       (* (reg8 *) OutVolt_PL__PRTDSI__OUT_SEL0) 
#define OutVolt_PL_PRTDSI__OUT_SEL1       (* (reg8 *) OutVolt_PL__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define OutVolt_PL_PRTDSI__SYNC_OUT       (* (reg8 *) OutVolt_PL__PRTDSI__SYNC_OUT) 


#if defined(OutVolt_PL__INTSTAT)  /* Interrupt Registers */

    #define OutVolt_PL_INTSTAT                (* (reg8 *) OutVolt_PL__INTSTAT)
    #define OutVolt_PL_SNAP                   (* (reg8 *) OutVolt_PL__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins OutVolt_PL_H */


/* [] END OF FILE */
