/*******************************************************************************
* File Name: VoutAdj.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_VoutAdj_H) /* Pins VoutAdj_H */
#define CY_PINS_VoutAdj_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "VoutAdj_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    VoutAdj_Write(uint8 value) ;
void    VoutAdj_SetDriveMode(uint8 mode) ;
uint8   VoutAdj_ReadDataReg(void) ;
uint8   VoutAdj_Read(void) ;
uint8   VoutAdj_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define VoutAdj_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define VoutAdj_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define VoutAdj_DM_RES_UP          PIN_DM_RES_UP
#define VoutAdj_DM_RES_DWN         PIN_DM_RES_DWN
#define VoutAdj_DM_OD_LO           PIN_DM_OD_LO
#define VoutAdj_DM_OD_HI           PIN_DM_OD_HI
#define VoutAdj_DM_STRONG          PIN_DM_STRONG
#define VoutAdj_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define VoutAdj_MASK               VoutAdj__MASK
#define VoutAdj_SHIFT              VoutAdj__SHIFT
#define VoutAdj_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define VoutAdj_PS                     (* (reg8 *) VoutAdj__PS)
/* Data Register */
#define VoutAdj_DR                     (* (reg8 *) VoutAdj__DR)
/* Port Number */
#define VoutAdj_PRT_NUM                (* (reg8 *) VoutAdj__PRT) 
/* Connect to Analog Globals */                                                  
#define VoutAdj_AG                     (* (reg8 *) VoutAdj__AG)                       
/* Analog MUX bux enable */
#define VoutAdj_AMUX                   (* (reg8 *) VoutAdj__AMUX) 
/* Bidirectional Enable */                                                        
#define VoutAdj_BIE                    (* (reg8 *) VoutAdj__BIE)
/* Bit-mask for Aliased Register Access */
#define VoutAdj_BIT_MASK               (* (reg8 *) VoutAdj__BIT_MASK)
/* Bypass Enable */
#define VoutAdj_BYP                    (* (reg8 *) VoutAdj__BYP)
/* Port wide control signals */                                                   
#define VoutAdj_CTL                    (* (reg8 *) VoutAdj__CTL)
/* Drive Modes */
#define VoutAdj_DM0                    (* (reg8 *) VoutAdj__DM0) 
#define VoutAdj_DM1                    (* (reg8 *) VoutAdj__DM1)
#define VoutAdj_DM2                    (* (reg8 *) VoutAdj__DM2) 
/* Input Buffer Disable Override */
#define VoutAdj_INP_DIS                (* (reg8 *) VoutAdj__INP_DIS)
/* LCD Common or Segment Drive */
#define VoutAdj_LCD_COM_SEG            (* (reg8 *) VoutAdj__LCD_COM_SEG)
/* Enable Segment LCD */
#define VoutAdj_LCD_EN                 (* (reg8 *) VoutAdj__LCD_EN)
/* Slew Rate Control */
#define VoutAdj_SLW                    (* (reg8 *) VoutAdj__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define VoutAdj_PRTDSI__CAPS_SEL       (* (reg8 *) VoutAdj__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define VoutAdj_PRTDSI__DBL_SYNC_IN    (* (reg8 *) VoutAdj__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define VoutAdj_PRTDSI__OE_SEL0        (* (reg8 *) VoutAdj__PRTDSI__OE_SEL0) 
#define VoutAdj_PRTDSI__OE_SEL1        (* (reg8 *) VoutAdj__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define VoutAdj_PRTDSI__OUT_SEL0       (* (reg8 *) VoutAdj__PRTDSI__OUT_SEL0) 
#define VoutAdj_PRTDSI__OUT_SEL1       (* (reg8 *) VoutAdj__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define VoutAdj_PRTDSI__SYNC_OUT       (* (reg8 *) VoutAdj__PRTDSI__SYNC_OUT) 


#if defined(VoutAdj__INTSTAT)  /* Interrupt Registers */

    #define VoutAdj_INTSTAT                (* (reg8 *) VoutAdj__INTSTAT)
    #define VoutAdj_SNAP                   (* (reg8 *) VoutAdj__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins VoutAdj_H */


/* [] END OF FILE */
