/*******************************************************************************
* File Name: VoutCtrl.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_VoutCtrl_H) /* Pins VoutCtrl_H */
#define CY_PINS_VoutCtrl_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "VoutCtrl_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    VoutCtrl_Write(uint8 value) ;
void    VoutCtrl_SetDriveMode(uint8 mode) ;
uint8   VoutCtrl_ReadDataReg(void) ;
uint8   VoutCtrl_Read(void) ;
uint8   VoutCtrl_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define VoutCtrl_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define VoutCtrl_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define VoutCtrl_DM_RES_UP          PIN_DM_RES_UP
#define VoutCtrl_DM_RES_DWN         PIN_DM_RES_DWN
#define VoutCtrl_DM_OD_LO           PIN_DM_OD_LO
#define VoutCtrl_DM_OD_HI           PIN_DM_OD_HI
#define VoutCtrl_DM_STRONG          PIN_DM_STRONG
#define VoutCtrl_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define VoutCtrl_MASK               VoutCtrl__MASK
#define VoutCtrl_SHIFT              VoutCtrl__SHIFT
#define VoutCtrl_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define VoutCtrl_PS                     (* (reg8 *) VoutCtrl__PS)
/* Data Register */
#define VoutCtrl_DR                     (* (reg8 *) VoutCtrl__DR)
/* Port Number */
#define VoutCtrl_PRT_NUM                (* (reg8 *) VoutCtrl__PRT) 
/* Connect to Analog Globals */                                                  
#define VoutCtrl_AG                     (* (reg8 *) VoutCtrl__AG)                       
/* Analog MUX bux enable */
#define VoutCtrl_AMUX                   (* (reg8 *) VoutCtrl__AMUX) 
/* Bidirectional Enable */                                                        
#define VoutCtrl_BIE                    (* (reg8 *) VoutCtrl__BIE)
/* Bit-mask for Aliased Register Access */
#define VoutCtrl_BIT_MASK               (* (reg8 *) VoutCtrl__BIT_MASK)
/* Bypass Enable */
#define VoutCtrl_BYP                    (* (reg8 *) VoutCtrl__BYP)
/* Port wide control signals */                                                   
#define VoutCtrl_CTL                    (* (reg8 *) VoutCtrl__CTL)
/* Drive Modes */
#define VoutCtrl_DM0                    (* (reg8 *) VoutCtrl__DM0) 
#define VoutCtrl_DM1                    (* (reg8 *) VoutCtrl__DM1)
#define VoutCtrl_DM2                    (* (reg8 *) VoutCtrl__DM2) 
/* Input Buffer Disable Override */
#define VoutCtrl_INP_DIS                (* (reg8 *) VoutCtrl__INP_DIS)
/* LCD Common or Segment Drive */
#define VoutCtrl_LCD_COM_SEG            (* (reg8 *) VoutCtrl__LCD_COM_SEG)
/* Enable Segment LCD */
#define VoutCtrl_LCD_EN                 (* (reg8 *) VoutCtrl__LCD_EN)
/* Slew Rate Control */
#define VoutCtrl_SLW                    (* (reg8 *) VoutCtrl__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define VoutCtrl_PRTDSI__CAPS_SEL       (* (reg8 *) VoutCtrl__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define VoutCtrl_PRTDSI__DBL_SYNC_IN    (* (reg8 *) VoutCtrl__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define VoutCtrl_PRTDSI__OE_SEL0        (* (reg8 *) VoutCtrl__PRTDSI__OE_SEL0) 
#define VoutCtrl_PRTDSI__OE_SEL1        (* (reg8 *) VoutCtrl__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define VoutCtrl_PRTDSI__OUT_SEL0       (* (reg8 *) VoutCtrl__PRTDSI__OUT_SEL0) 
#define VoutCtrl_PRTDSI__OUT_SEL1       (* (reg8 *) VoutCtrl__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define VoutCtrl_PRTDSI__SYNC_OUT       (* (reg8 *) VoutCtrl__PRTDSI__SYNC_OUT) 


#if defined(VoutCtrl__INTSTAT)  /* Interrupt Registers */

    #define VoutCtrl_INTSTAT                (* (reg8 *) VoutCtrl__INTSTAT)
    #define VoutCtrl_SNAP                   (* (reg8 *) VoutCtrl__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins VoutCtrl_H */


/* [] END OF FILE */
