/*******************************************************************************
* File Name: VoutFbk.h  
* Version 2.0
*
* Description:
*  This file containts Control Register function prototypes and register defines
*
* Note:
*
********************************************************************************
* Copyright 2008-2014, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions, 
* disclaimers, and limitations in the end user license agreement accompanying 
* the software package with which this file was provided.
*******************************************************************************/

#if !defined(CY_PINS_VoutFbk_H) /* Pins VoutFbk_H */
#define CY_PINS_VoutFbk_H

#include "cytypes.h"
#include "cyfitter.h"
#include "cypins.h"
#include "VoutFbk_aliases.h"


/***************************************
*        Function Prototypes             
***************************************/    

void    VoutFbk_Write(uint8 value) ;
void    VoutFbk_SetDriveMode(uint8 mode) ;
uint8   VoutFbk_ReadDataReg(void) ;
uint8   VoutFbk_Read(void) ;
uint8   VoutFbk_ClearInterrupt(void) ;


/***************************************
*           API Constants        
***************************************/

/* Drive Modes */
#define VoutFbk_DM_ALG_HIZ         PIN_DM_ALG_HIZ
#define VoutFbk_DM_DIG_HIZ         PIN_DM_DIG_HIZ
#define VoutFbk_DM_RES_UP          PIN_DM_RES_UP
#define VoutFbk_DM_RES_DWN         PIN_DM_RES_DWN
#define VoutFbk_DM_OD_LO           PIN_DM_OD_LO
#define VoutFbk_DM_OD_HI           PIN_DM_OD_HI
#define VoutFbk_DM_STRONG          PIN_DM_STRONG
#define VoutFbk_DM_RES_UPDWN       PIN_DM_RES_UPDWN

/* Digital Port Constants */
#define VoutFbk_MASK               VoutFbk__MASK
#define VoutFbk_SHIFT              VoutFbk__SHIFT
#define VoutFbk_WIDTH              1u


/***************************************
*             Registers        
***************************************/

/* Main Port Registers */
/* Pin State */
#define VoutFbk_PS                     (* (reg8 *) VoutFbk__PS)
/* Data Register */
#define VoutFbk_DR                     (* (reg8 *) VoutFbk__DR)
/* Port Number */
#define VoutFbk_PRT_NUM                (* (reg8 *) VoutFbk__PRT) 
/* Connect to Analog Globals */                                                  
#define VoutFbk_AG                     (* (reg8 *) VoutFbk__AG)                       
/* Analog MUX bux enable */
#define VoutFbk_AMUX                   (* (reg8 *) VoutFbk__AMUX) 
/* Bidirectional Enable */                                                        
#define VoutFbk_BIE                    (* (reg8 *) VoutFbk__BIE)
/* Bit-mask for Aliased Register Access */
#define VoutFbk_BIT_MASK               (* (reg8 *) VoutFbk__BIT_MASK)
/* Bypass Enable */
#define VoutFbk_BYP                    (* (reg8 *) VoutFbk__BYP)
/* Port wide control signals */                                                   
#define VoutFbk_CTL                    (* (reg8 *) VoutFbk__CTL)
/* Drive Modes */
#define VoutFbk_DM0                    (* (reg8 *) VoutFbk__DM0) 
#define VoutFbk_DM1                    (* (reg8 *) VoutFbk__DM1)
#define VoutFbk_DM2                    (* (reg8 *) VoutFbk__DM2) 
/* Input Buffer Disable Override */
#define VoutFbk_INP_DIS                (* (reg8 *) VoutFbk__INP_DIS)
/* LCD Common or Segment Drive */
#define VoutFbk_LCD_COM_SEG            (* (reg8 *) VoutFbk__LCD_COM_SEG)
/* Enable Segment LCD */
#define VoutFbk_LCD_EN                 (* (reg8 *) VoutFbk__LCD_EN)
/* Slew Rate Control */
#define VoutFbk_SLW                    (* (reg8 *) VoutFbk__SLW)

/* DSI Port Registers */
/* Global DSI Select Register */
#define VoutFbk_PRTDSI__CAPS_SEL       (* (reg8 *) VoutFbk__PRTDSI__CAPS_SEL) 
/* Double Sync Enable */
#define VoutFbk_PRTDSI__DBL_SYNC_IN    (* (reg8 *) VoutFbk__PRTDSI__DBL_SYNC_IN) 
/* Output Enable Select Drive Strength */
#define VoutFbk_PRTDSI__OE_SEL0        (* (reg8 *) VoutFbk__PRTDSI__OE_SEL0) 
#define VoutFbk_PRTDSI__OE_SEL1        (* (reg8 *) VoutFbk__PRTDSI__OE_SEL1) 
/* Port Pin Output Select Registers */
#define VoutFbk_PRTDSI__OUT_SEL0       (* (reg8 *) VoutFbk__PRTDSI__OUT_SEL0) 
#define VoutFbk_PRTDSI__OUT_SEL1       (* (reg8 *) VoutFbk__PRTDSI__OUT_SEL1) 
/* Sync Output Enable Registers */
#define VoutFbk_PRTDSI__SYNC_OUT       (* (reg8 *) VoutFbk__PRTDSI__SYNC_OUT) 


#if defined(VoutFbk__INTSTAT)  /* Interrupt Registers */

    #define VoutFbk_INTSTAT                (* (reg8 *) VoutFbk__INTSTAT)
    #define VoutFbk_SNAP                   (* (reg8 *) VoutFbk__SNAP)

#endif /* Interrupt Registers */

#endif /* End Pins VoutFbk_H */


/* [] END OF FILE */
