/*******************************************************************************
* This file is automatically generated by PSoC Creator
* and should not be edited by hand.
*
* This file is necessary for your project to build.
* Please do not delete it.
********************************************************************************
* Copyright 2008-2011, Cypress Semiconductor Corporation.  All rights reserved.
* You may use this file only in accordance with the license, terms, conditions,
* disclaimers, and limitations in the end user license agreement accompanying
* the software package with which this file was provided.
*******************************************************************************/
#ifndef DEVICE_H
#define DEVICE_H
#include <project.h>

#define VOLTAGE_MAX 30.0   
#define CURRENT_MAX 5.0   
#define VOLTAGE_MIN 0.0   
#define CURRENT_MIN 0.01  
	
#define OUTSTAT_ErrOverVoltage 				0x01 
#define OUTSTAT_ErrOverCurrent 				0x02 
#define OUTSTAT_ErrPowerMonFail				0x04
#define OUTSTAT_OutputIsON						0x08
#define OUTSTAT_ErrALL						(OUTSTAT_ErrOverVoltage | OUTSTAT_ErrOverCurrent | OUTSTAT_ErrPowerMonFail)
	
#define ERR_None 0   
#define ERR_MASK 								0x0FFF 
#define ERR_OneWire_NoDevice 		0x0001    
#define ERR_OneWire_BusShort 		0x0002   
#define ERR_OneWire_Config 			0x0004 
#define ERR_Mouse_NoDevice 			0x0008 
#define ERR_Mouse_NoWheel 			0x0010 
#define ERR_Output_HighCurr			0x0020 
#define ERR_Output_HighVoltage	0x0040 
#define ERR_Output_PowerMonFail	0x0080 
#define ERR_Output_NoBreaker		0x0100 
#define ERR_Calibrate						0x0200 
#define ERR_NewError						0x8000 
#define ERR_SYSTEM							(ERR_OneWire_NoDevice | ERR_OneWire_BusShort | ERR_OneWire_Config | ERR_Mouse_NoDevice | ERR_Mouse_NoWheel) 
#define ERR_OUTPUT							(ERR_Output_HighCurr | ERR_Output_HighVoltage | ERR_Output_PowerMonFail | ERR_Output_NoBreaker) 
	
#define WM_Init 						0x0000  /*Иницилизация*/
#define WM_ModeChange				0x8000  /*Режим изменен*/
#define WM_HwPrCurrLowSense	0x4000  /*Низкая чувствительность аппаратной защиты по току*/
#define WM_ModeMASK 				0x000F
#define WM_PowerOFF 				0x0001	/*Выключено*/
#define WM_VoltStab 				0x0002	/*Режим стабилизации напряжения*/
#define WM_CurrStab 				0x0003	/*Режим стабилизации тока*/	
#define WM_BatteryChrg			0x0004  /*Режим зарядного устройства*/

#define WM_FIRST   				  WM_VoltStab /*первый режим работы*/	
#define WM_LAST   				  WM_BatteryChrg /*последний режим работы*/	
#define WM_INC   				    WM_PowerOFF /*значение для инкремента режима работы*/		

#define WM_OutON 						0x8000
	
#define LM_MASK 							0x00F0
#define LM_NewData   					0x8000  /*данные для дисплея изменились, обновить без задержек*/
#define LM_ExcStored   				0x4000  /*Необходимость сохранения*/
#define LM_IndicError 				0x2000  /*Индикация ошибок*/
#define LM_ChangeValue 				0x1000  /*изменение в рамках выбранного меню*/
#define LM_PowerOFF  					0x0000  /*индикация при выключенном устройстве*/
#define LM_PowerON  					0x0010  /*индикация при включенном устройстве*/
#define LM_SelectWorkMode   	0x0020  /*выбор режима работы*/
#define LM_CurrentChng   			0x0030  /*установить значение тока*/
#define LM_VoltageChng   			0x0040  /*установить значение напряжения*/
#define LM_IndPower   				0x0050  /*индикация потребляемой мощности*/
#define LM_IndTemper   				0x0060  /*индикация температуры внутри устройства*/
#define LM_IntVoltages 				0x0070  /*индикация напряжений внутренних стабилизаторов*/
#define LM_Errors 						0x0080  /*ошибки*/
	
#define LM_FIRST   				    LM_PowerON /*первый пункт меню дисплея*/	
#define LM_LAST   				    LM_Errors /*последний пункт меню дисплея*/	
#define LM_INC   				      LM_PowerON /*значение для инкремента пунктов меню*/	
	
#define LM_SelWMMASK 					0x000F
#define LM_SelWM_VoltStab 		0x0001
#define LM_SelWM_CurrStab 		0x0002
#define LM_SelWM_BatteryChrg	0x0003
	
#define LM_SelWM_FIRST   			LM_SelWM_VoltStab /*первый пункт меню*/	
#define LM_SelWM_LAST   			LM_SelWM_BatteryChrg /*последний пункт меню*/	
#define LM_SelWM_INC   				LM_SelWM_VoltStab /*значение для инкремента пунктов меню*/		

#define KEY_DOWN 						0x01 
#define KEY_UP 							0x02 
#define KEY_OK 						0x04 
#define KEY_POWER					0x08 
#define KEY_CAPSenseHi		0x10 
#define KEY_CAPSenseLo		0x20 
	
#define MSS_MSWheelMASK				0x0F 
#define MSS_None							0x00
#define MSS_MSBtnLeft					0x10 
#define MSS_MSBtnRight				0x20 
#define MSS_MSBtnMid					0x40 
	
typedef int8 bool;	
#define FALSE 0 
#define TRUE !FALSE	
	
typedef uint16 TSysClk, * PTSysClk;	
	
typedef int16 TError;	
typedef int16 TWorkMode;	
typedef int16 TLCDMenu;
	
typedef struct _TDevice{
	TError Error;
	TWorkMode WorkMode;
	TLCDMenu LCDMenu;
	float VoltageSP;
	float CurrentSP;
	uint8 EEPR_CRC; //контрольная сумма для проверки при чтении из ЕЕПРОМ
	uint8 EEPR_DUMMY;  //подгонка TDevice под row ЕЕПРОМ = 16 байт
	float VoltageMeas;
	float VoltageCutOff;
	bool VoltageMeasNew;
	float VoltageDrop;
	float CurrentMeas;
	float CurrentMax;
	float CurrentOffset;
	float VoltStab12V;
	float VoltStab24V;
	float ACVoltage;
  int8 RadiatorTemperature;          //Температура радиатора охлаждения
  int8 CPUTemperature;          //Температура радиатора охлаждения
	bool HwPrSupressed;
} TDevice, * PTDevice;	
	
extern TDevice PowerUnit;

#define TEMPER_ERR 127
#define TEMPER_NOT_CONV -128
extern bool CheckTemper(void);

extern bool SysClk_CheckPeriod(PTSysClk pCounter, TSysClk Period);
extern bool SysClk_OverPeriod(PTSysClk pCounter, TSysClk Period);
extern TSysClk SysClk_GetPeriod(TSysClk Counter) reentrant;

extern CY_ISR_PROTO(MouseIrqHandler);
extern void MouseHandler (void);

	
#define MainPowerON() {MAIN_PWR_Write(0x01);}
#define MainPowerOFF() {MAIN_PWR_Write(0x00);}
#define RelayPowerON() {OUT_ON_R_Write(0x01);}
#define RelayPowerOFF() {OUT_ON_R_Write(0x00);}
#define OutputDischargeON() {OUT_DISCH_Write(0x01);}
#define OutputDischargeOFF() {OUT_DISCH_Write(0x00);}

#define WorkMode_ModeGET (PowerUnit.WorkMode & WM_ModeMASK)
#define WorkMode_ModeSET(MODE) {PowerUnit.WorkMode = ((PowerUnit.WorkMode & ~WM_ModeMASK) | MODE) | WM_ModeChange;}

#define HwPrNoOverVoltage_ON()  ControlOutput_Write((ControlOutput_Read() | 0x04));
#define HwPrNoOverVoltage_OFF()  ControlOutput_Write((ControlOutput_Read() & ~0x04));
#define HwPrNoOverCurrent_ON()  ControlOutput_Write((ControlOutput_Read() | 0x10));
#define HwPrNoOverCurrent_OFF()  ControlOutput_Write((ControlOutput_Read() & ~0x10));
#define HwPrErrorClr()	{ControlOutput_Write(ControlOutput_Read() | 0x08);	CyDelay(1); ControlOutput_Write(ControlOutput_Read() & ~0x08);}	
	

#define LCDMenu_ModeGET (PowerUnit.LCDMenu & LM_MASK)
#define LCDMenu_ModeSET(MODE) {PowerUnit.LCDMenu = (PowerUnit.LCDMenu & ~LM_MASK) | (MODE);}
#define LCDMenu_NewData() {PowerUnit.LCDMenu |= LM_NewData;}
#define LCDMenu_IndicErrorSET() {PowerUnit.LCDMenu |= LM_IndicError;}
#define LCDMenu_IndicErrorRESET() {PowerUnit.LCDMenu &= (~LM_IndicError);}
#define LCDMenu_SelWMGET (PowerUnit.LCDMenu & LM_SelWMMASK)
#define LCDMenu_SelWMSET(MODE) {PowerUnit.LCDMenu = (PowerUnit.LCDMenu & ~LM_SelWMMASK) | (MODE);}

#define GlobalError_SET(ERROR) {if (!(PowerUnit.Error & ERROR)) {PowerUnit.Error |= ERR_NewError;LCDMenu_IndicErrorSET();} PowerUnit.Error |= ERROR; }
#define GlobalError_CLEAR(ERROR) {PowerUnit.Error &= ~(ERROR); if (!(PowerUnit.Error & ERR_MASK)) {PowerUnit.Error &= ~ERR_NewError; }}

#define LED_HighCurrentIsON()  	LED_Driver_SetRC(0, 7)
#define LED_HighCurrentIsOFF()  	LED_Driver_ClearRC(0, 7)

#define LED_HwPrCurrLowSense()  	LED_Driver_SetRC(6, 7)
#define LED_HwPrCurrNrmSense()  	LED_Driver_ClearRC(6, 7)

#define LED_HwPrSupressON()  		LED_Driver_SetRC(7, 7)
#define LED_HwPrSupressOFF()  	LED_Driver_ClearRC(7, 7)

#define LED_Load10IsON()  		LED_Driver_SetRC(7, 6)
#define LED_Load20IsON()  		LED_Driver_SetRC(6, 6)
#define LED_Load30IsON()  		LED_Driver_SetRC(5, 6)
#define LED_Load40IsON()  		LED_Driver_SetRC(4, 6)
#define LED_Load50IsON()  		LED_Driver_SetRC(3, 6)
#define LED_Load60IsON()  		LED_Driver_SetRC(2, 6)
#define LED_Load70IsON()  		LED_Driver_SetRC(1, 6)
#define LED_Load80IsON()  		LED_Driver_SetRC(0, 6)
#define LED_Load90IsON()  		LED_Driver_SetRC(2, 7)
#define LED_Load100IsON()  		LED_Driver_SetRC(1, 7)

#define LED_Load10IsOFF()  		LED_Driver_ClearRC(7, 6)
#define LED_Load20IsOFF()  		LED_Driver_ClearRC(6, 6)
#define LED_Load30IsOFF()  		LED_Driver_ClearRC(5, 6)
#define LED_Load40IsOFF()  		LED_Driver_ClearRC(4, 6)
#define LED_Load50IsOFF()  		LED_Driver_ClearRC(3, 6)
#define LED_Load60IsOFF()  		LED_Driver_ClearRC(2, 6)
#define LED_Load70IsOFF()  		LED_Driver_ClearRC(1, 6)
#define LED_Load80IsOFF()  		LED_Driver_ClearRC(0, 6)
#define LED_Load90IsOFF()  		LED_Driver_ClearRC(2, 7)
#define LED_Load100IsOFF()  	LED_Driver_ClearRC(1, 7)

#define LED_OutputIsON()  	LED_Driver_SetRC(4, 7)
#define LED_OutputIsOFF()  	LED_Driver_ClearRC(4, 7)

#define LED_CAPSenseIsHigh()  	LED_Driver_SetRC(3, 7)
#define LED_CAPSenseIsLow()  	LED_Driver_ClearRC(3, 7)

#define LED_ErrorIsON() 	 	LED_Driver_SetRC(5, 7)
#define LED_ErrorIsOFF()  	LED_Driver_ClearRC(5, 7)

#define Current_SHUNT_Ohm  0.06
#define Current_OpAmpl_GAIN  8.0
#define Current_CompensResDiv  (1 + (1.0 / 14.0) /*резисторы в цепи подтяжки изм. тока (OutCurr_Comp)*/)
//#define Current_Range_5A  OutCurrAmpl_0_GAIN_16
//#define Current_Range_2_5A  OutCurrAmpl_0_GAIN_32
//#define Current_SetRange(RANGE)  				{PowerUnit.CurrentAmplGain = RANGE; OutCurrAmpl_0_SetGain(RANGE);}
//#define Current_OpAmpl_OffsetMilliVolt  19.5  /*Величина смещения опер. усилителя по входу измерения*/

#define VoltOut_ResistDivRatio  8.0  /*Соотношение резистивного делителя по входу измерителя выходного напряжения*/
#define VoltOut_OpAmpl_OffsetMilliVolt  0.0  /*Величина смещения опер. усилителя по входу измерения*/
#define Volt12V_ResistDivRatio  4.0  /*Соотношение резистивного делителя по входу измерителя стабилизатора 12В*/
#define Volt24V_ResistDivRatio  8.0  /*Соотношение резистивного делителя по входу измерителя стабилизатора 24В*/
#define VoltAC_ResistDivRatio  (8.0 * (220.0 / 12.0))  /*Соотношение резистивного делителя по входу измерителя напряжения сети 220В*/


#define CtrlVolt_ResistDivRati  8.0  /*Соотношение резистивного делителя по входу измерителя выходного напряжения*/

extern void InitSystem (void);
extern void InitDisplay (void);
extern void InitFan (void);
extern void InitOutput (void);
extern void InitMouse (void);
extern void InitAnalog (void);

extern void LCDMenu_ModeNEXT(void);
extern void LCDMenu_ModePREV(void);
extern void LCDMenuHandler (void);
extern void LCDMenuBackToMainMenuReset (void);
extern void WorkModeHandler (void);
extern void WorkMode_ModeNEXT(void);
extern void WorkMode_ModePREV(void);
extern void HwPrSupress(bool AOn);

extern void StartLEDDisplay (void);
extern void StopLEDDisplay (void);
extern void LEDDisplay_ShowMeasured (void);
extern void LEDDisplay_ShowBarInVoltStab (void);
extern void LEDDisplay_ShowBarInCurrStab (void);
extern void LEDDisplay_ShowBarInBatteryChrg (void);

extern void OutputControl (bool AOn);
extern void OutputControlChng (void);
extern uint8 ReadOutputError (void);
extern bool ResetError(void);
extern void OutputControlFastSw (bool AOn);
extern void VoltageSP_Inc (float IncValue);
extern void VoltageSP_Dec (float DecValue);
extern void CurrentSP_Inc (float IncValue);
extern void CurrentSP_Dec (float DecValue);

extern bool CheckKeyPressed (int8 Key);
extern bool CheckKeyPressed_1s (int8 Key);
extern bool CheckKeyPressed_4s (int8 Key);

extern void ADCHandler (void);
extern bool CalibrateAnalog(void);//bool CalibrateCurrentChanel (void);
extern uint16 VoltageSP2DACValue(float VoltageSP);
extern void OnPowerUP_SetVoltage (bool AWithRelayON);
extern void ResetStabilizeCurrentVDACValue (void);
extern bool StabilizeCurrent (TSysClk MaxDuration, float Current);
extern float GetBatteryChargeLevel(void);
#endif
/* [] END OF FILE */
